package fovea.ganomede {
	import fovea.ganomede.GanomedeService;
	import fovea.async.Deferred;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeClient;
	import fovea.ganomede.ApiClient;
	import flash.Boot;
	public class GanomedeRegistry extends fovea.ganomede.ApiClient {
		public function GanomedeRegistry(client : fovea.ganomede.GanomedeClient = null,url : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super(url);
			this.client = client;
		}}
		
		public var initialized : Boolean = false;
		public var services : Array = new Array();
		public var client : fovea.ganomede.GanomedeClient = null;
		public function initialize() : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeRegistry = this;
			return this.getServices().then(this.storeServices).then(function(o : *) : void {
				_g.initialized = true;
			});
		}
		
		public function getServices() : fovea.async.Promise {
			return this.cachedAjax("GET","/services",{ parse : this.parseServices}).then(this.storeServices);
		}
		
		protected function storeServices(result : *) : void {
			if(result.data && result.data.length) this.services = ((result.data) as Array);
		}
		
		public function getServicesAsync() : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeRegistry = this;
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			this.ajax("GET","/services",{ parse : this.parseServices, cache : true}).then(this.storeServices).then(function(obj : *) : void {
				deferred.resolve(_g.services);
			}).error(deferred.reject);
			return deferred;
		}
		
		protected function parseServices(obj : *) : * {
			var array : Array;
			array = (function($this:GanomedeRegistry) : Array {
				var $r : Array;
				var $t : * = obj;
				if(Std._is($t,Array)) (($t) as Array);
				else throw "Class cast error";
				$r = $t;
				return $r;
			}(this));
			{
				var _g1 : int = 0;
				var _g : int = array.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					array[i] = new fovea.ganomede.GanomedeService(array[i]);
				}
			};
			return array;
		}
		
		public function getService(type : String,major : int) : fovea.ganomede.GanomedeService {
			{
				var _g1 : int = 0;
				var _g : int = this.services.length;
				while(_g1 < _g) {
					var i : int = _g1++;
					if(this.services[i].type == type && this.services[i].versionMajor() == major) return this.services[i];
				}
			};
			return null;
		}
		
	}
}
