package fovea.ganomede {
	import flash.Boot;
	public class GanomedeUser {
		public function GanomedeUser(obj : * = null) : void { if( !flash.Boot.skip_constructor ) {
			if(obj != null) {
				this.username = obj.username;
				this.givenName = obj.givenName;
				this.surname = obj.surname;
				this.email = obj.email;
				this.password = obj.password;
				this.set_token(obj.token);
				this.facebookId = obj.facebookId;
				this.facebookToken = obj.facebookToken;
			}
		}}
		
		public var username : String;
		public var givenName : String;
		public var surname : String;
		public var email : String;
		public var password : String;
		public var facebookId : String;
		public var facebookToken : String;
		public function get token() : String { return $token; }
		public function set token( __v : String ) : void { set_token(__v); }
		protected var $token : String = null;
		public function set_token(value : String) : String {
			this.$token = value;
			if(this.token == "") this.$token = null;
			return this.token;
		}
		
		public function isAuthenticated() : Boolean {
			return !(this.token == null || this.token == "");
		}
		
		public function fromJSON(obj : *) : void {
			if(obj == null) return;
			if(obj.username) this.username = obj.username;
			if(obj.givenName) this.givenName = obj.givenName;
			if(obj.surname) this.surname = obj.surname;
			if(obj.email) this.email = obj.email;
			if(obj.password) this.password = obj.password;
			if(obj.token) this.set_token(obj.token);
			if(obj.facebookId) this.facebookId = obj.facebookId;
			if(obj.facebookToken) this.facebookToken = obj.facebookToken;
		}
		
		public function toJSON() : * {
			return { username : this.username, givenName : this.givenName, surname : this.surname, email : this.email, password : this.password, token : this.token, facebookId : this.facebookId, facebookToken : this.facebookToken}
		}
		
	}
}
