package fovea.net {
	import flash.events.Event;
	import fovea.net.AjaxOpenFL;
	import fovea.events.Events;
	import flash.events.EventDispatcher;
	import fovea.net.IAjax;
	import fovea.async.Promise;
	import haxe.Log;
	import fovea.net.AjaxError;
	import flash.Boot;
	public class Ajax extends fovea.events.Events implements fovea.net.IAjax{
		public function Ajax(url : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super();
			this.url = url;
			this.impl = (fovea.net.Ajax.implFactory)(this);
		}}
		
		public var impl : fovea.net.IAjax = null;
		public var url : String;
		public function beforeAjax(options : *) : void {
		}
		
		public function afterAjax(options : *,obj : *) : void {
		}
		
		public function ajaxError(code : String,status : int = 0,data : * = null,url : String = null) : fovea.net.AjaxError {
			return new fovea.net.AjaxError(code,status,data,url);
		}
		
		public function ajax(method : String,path : String,options : * = null) : fovea.async.Promise {
			return this.impl.ajax(method,path,options);
		}
		
		static public var verbose : Boolean = false;
		static public var dtrace : Function = function(txt : String) : void {
			if(fovea.net.Ajax.verbose) haxe.Log._trace(txt,{ fileName : "Ajax.hx", lineNumber : 31, className : "fovea.net.Ajax", methodName : "dtrace"});
		}
		static public var implFactory : Function = fovea.net.AjaxOpenFL.factory;
		static public var ONLINE : String = "online";
		static public var OFFLINE : String = "offline";
		static public var onlineEvent : flash.events.Event = new flash.events.Event("online");
		static public var offlineEvent : flash.events.Event = new flash.events.Event("offline");
		static public var connection : flash.events.EventDispatcher = new flash.events.EventDispatcher();
		static public function when(status : String,fn : Function) : void {
			fovea.net.Ajax.connection.addEventListener(status,fn);
		}
		
		static public function stopListening(status : String,fn : Function) : void {
			fovea.net.Ajax.connection.removeEventListener(status,fn);
		}
		
	}
}
