(function ($hx_exports) { "use strict";
$hx_exports.fovea = $hx_exports.fovea || {};
$hx_exports.fovea.utils = $hx_exports.fovea.utils || {};
;$hx_exports.fovea.ganomede = $hx_exports.fovea.ganomede || {};
$hx_exports.fovea.ganomede.helpers = $hx_exports.fovea.ganomede.helpers || {};
;$hx_exports.fovea.ganomede.models = $hx_exports.fovea.ganomede.models || {};
;$hx_exports.fovea.net = $hx_exports.fovea.net || {};
;$hx_exports.fovea.events = $hx_exports.fovea.events || {};
;$hx_exports.fovea.async = $hx_exports.fovea.async || {};
function $extend(from, fields) {
	function Inherit() {} Inherit.prototype = from; var proto = new Inherit();
	for (var name in fields) proto[name] = fields[name];
	if( fields.toString !== Object.prototype.toString ) proto.toString = fields.toString;
	return proto;
}
var HxOverrides = function() { };
HxOverrides.__name__ = true;
HxOverrides.cca = function(s,index) {
	var x = s.charCodeAt(index);
	if(x != x) return undefined;
	return x;
};
HxOverrides.indexOf = function(a,obj,i) {
	var len = a.length;
	if(i < 0) {
		i += len;
		if(i < 0) i = 0;
	}
	while(i < len) {
		if(a[i] === obj) return i;
		i++;
	}
	return -1;
};
HxOverrides.remove = function(a,obj) {
	var i = HxOverrides.indexOf(a,obj,0);
	if(i == -1) return false;
	a.splice(i,1);
	return true;
};
HxOverrides.iter = function(a) {
	return { cur : 0, arr : a, hasNext : function() {
		return this.cur < this.arr.length;
	}, next : function() {
		return this.arr[this.cur++];
	}};
};
var IMap = function() { };
IMap.__name__ = true;
Math.__name__ = true;
var Reflect = function() { };
Reflect.__name__ = true;
Reflect.field = function(o,field) {
	try {
		return o[field];
	} catch( e ) {
		return null;
	}
};
Reflect.fields = function(o) {
	var a = [];
	if(o != null) {
		var hasOwnProperty = Object.prototype.hasOwnProperty;
		for( var f in o ) {
		if(f != "__id__" && f != "hx__closures__" && hasOwnProperty.call(o,f)) a.push(f);
		}
	}
	return a;
};
var Std = function() { };
Std.__name__ = true;
Std.string = function(s) {
	return js.Boot.__string_rec(s,"");
};
Std["int"] = function(x) {
	return x | 0;
};
Std.parseInt = function(x) {
	var v = parseInt(x,10);
	if(v == 0 && (HxOverrides.cca(x,1) == 120 || HxOverrides.cca(x,1) == 88)) v = parseInt(x);
	if(isNaN(v)) return null;
	return v;
};
var StringBuf = function() {
	this.b = "";
};
StringBuf.__name__ = true;
StringBuf.prototype = {
	__class__: StringBuf
};
var StringTools = function() { };
StringTools.__name__ = true;
StringTools.replace = function(s,sub,by) {
	return s.split(sub).join(by);
};
StringTools.hex = function(n,digits) {
	var s = "";
	var hexChars = "0123456789ABCDEF";
	do {
		s = hexChars.charAt(n & 15) + s;
		n >>>= 4;
	} while(n > 0);
	if(digits != null) while(s.length < digits) s = "0" + s;
	return s;
};
var fovea = {};
fovea.async = {};
fovea.async.Promise = $hx_exports.fovea.async.Promise = function() { };
fovea.async.Promise.__name__ = true;
fovea.async.Promise.prototype = {
	__class__: fovea.async.Promise
};
fovea.async.Deferred = $hx_exports.fovea.async.Deferred = function() {
	this._state = 0;
	this._failListeners = new Array();
	this._completeListeners = new Array();
};
fovea.async.Deferred.__name__ = true;
fovea.async.Deferred.__interfaces__ = [fovea.async.Promise];
fovea.async.Deferred.prototype = {
	resolve: function(outcome) {
		if(this._state != 0) return this;
		this._outcome = outcome;
		this._state = 1;
		var _g1 = 0;
		var _g = this._completeListeners.length;
		while(_g1 < _g) {
			var i = _g1++;
			this._completeListeners[i](this._outcome);
		}
		this.clearListeners();
		this.invokeFinalCallback();
		return this;
	}
	,reject: function(error) {
		if(this._state != 0) return this;
		if(error != null) this._outcome = error; else this._outcome = new openfl.errors.Error("Promise Rejected");
		this._state = 2;
		var _g1 = 0;
		var _g = this._failListeners.length;
		while(_g1 < _g) {
			var i = _g1++;
			this._failListeners[i](this._outcome);
		}
		this.clearListeners();
		this.invokeFinalCallback();
		return this;
	}
	,abort: function() {
		this._state = 3;
		this._outcome = null;
		this._finalCallback = null;
		this.clearListeners();
	}
	,then: function(callback) {
		if(this._state == 0) this._completeListeners.push(callback); else if(this._state == 1) callback(this._outcome);
		return this;
	}
	,error: function(callback) {
		if(this._state == 0) this._failListeners.push(callback); else if(this._state == 2) callback(this._outcome);
		return this;
	}
	,always: function(callback) {
		if(this._state == 0) this._finalCallback = callback; else callback();
		return this;
	}
	,clearListeners: function() {
		while(this._completeListeners.length > 0) this._completeListeners.pop();
		while(this._failListeners.length > 0) this._failListeners.pop();
	}
	,invokeFinalCallback: function() {
		if(this._finalCallback != null) {
			this._finalCallback();
			this._finalCallback = null;
		}
	}
	,invert: function() {
		var deferred = new fovea.async.Deferred();
		this.then($bind(deferred,deferred.reject)).error($bind(deferred,deferred.resolve));
		return deferred;
	}
	,__class__: fovea.async.Deferred
};
fovea.async.Parallel = $hx_exports.fovea.async.Parallel = function() { };
fovea.async.Parallel.__name__ = true;
fovea.async.Parallel.run = function(fn) {
	var deferred = new fovea.async.Deferred();
	if(fn.length == 0) {
		deferred.resolve();
		return deferred;
	}
	haxe.Timer.delay((function($this) {
		var $r;
		var onTick = function() {
			var nCalls = 0;
			var done = function(outcome) {
				nCalls += 1;
				if(nCalls == 2) deferred.resolve();
			};
			var f = fn.shift();
			f().then(done).error($bind(deferred,deferred.reject));
			fovea.async.Parallel.run(fn).then(done).error($bind(deferred,deferred.reject));
		};
		$r = onTick;
		return $r;
	}(this)),0);
	return deferred;
};
fovea.async.Parallel.runWithArgs = function(args,fn) {
	return fovea.async.Parallel.privRunWithArgs(args.slice(),fn);
};
fovea.async.Parallel.privRunWithArgs = function(args,fn) {
	var deferred = new fovea.async.Deferred();
	if(args.length == 0) {
		deferred.resolve();
		return deferred;
	}
	haxe.Timer.delay((function($this) {
		var $r;
		var onTick = function() {
			var nCalls = 0;
			var done = function(outcome) {
				nCalls += 1;
				if(nCalls == 2) deferred.resolve();
			};
			var a = args.shift();
			fn(a).then(done).error($bind(deferred,deferred.reject));
			fovea.async.Parallel.privRunWithArgs(args,fn).then(done).error($bind(deferred,deferred.reject));
		};
		$r = onTick;
		return $r;
	}(this)),0);
	return deferred;
};
fovea.async.PromiseRunner = $hx_exports.fovea.async.PromiseRunner = function() { };
fovea.async.PromiseRunner.__name__ = true;
fovea.async.PromiseRunner.prototype = {
	__class__: fovea.async.PromiseRunner
};
fovea.async.Waterfall = $hx_exports.fovea.async.Waterfall = function() { };
fovea.async.Waterfall.__name__ = true;
fovea.async.Waterfall.run = function(fn) {
	var deferred = new fovea.async.Deferred();
	if(fn.length == 0) {
		deferred.resolve();
		return deferred;
	}
	haxe.Timer.delay((function($this) {
		var $r;
		var onTick = function() {
			var f = fn.shift();
			f().then((function($this) {
				var $r;
				var onResolve = function(outcome) {
					fovea.async.Waterfall.run(fn).then($bind(deferred,deferred.resolve)).error($bind(deferred,deferred.reject));
				};
				$r = onResolve;
				return $r;
			}(this))).error($bind(deferred,deferred.reject));
		};
		$r = onTick;
		return $r;
	}(this)),0);
	return deferred;
};
fovea.events = {};
fovea.events.Event = $hx_exports.fovea.events.Event = function(type) {
	this.type = type;
};
fovea.events.Event.__name__ = true;
fovea.events.Event.prototype = {
	__class__: fovea.events.Event
};
fovea.events.Events = $hx_exports.fovea.events.Events = function() { };
fovea.events.Events.__name__ = true;
fovea.events.Events.__super__ = (EventEmitter__0||require("events").EventEmitter);
fovea.events.Events.prototype = $extend((EventEmitter__0||require("events").EventEmitter).prototype,{
	addEventListener: function(event,callback) {
		this.on(event,callback);
	}
	,off: function(event,callback) {
		this.removeListener(event,callback);
	}
	,removeEventListener: function(event,callback) {
		this.removeListener(event,callback);
	}
	,dispatchEvent: function(event) {
		this.emit(event.type,event);
	}
	,__class__: fovea.events.Events
});
fovea.net = {};
fovea.net.Ajax = $hx_exports.fovea.net.Ajax = function(url) {
	this.url = url;
	this.protocol = url.split(":")[0];
	this.path = "";
	var array = url.split("/");
	var _g1 = 3;
	var _g = array.length;
	while(_g1 < _g) {
		var i = _g1++;
		this.path += "/" + array[i];
	}
	var hostPort = url.split("/")[2];
	this.host = hostPort.split(":")[0];
	if(this.protocol == "https") this.port = 443; else this.port = 80;
	if(this.host != hostPort) this.port = Std.parseInt(hostPort.split(":")[1]);
};
fovea.net.Ajax.__name__ = true;
fovea.net.Ajax.dtrace = function(txt) {
	if(fovea.net.Ajax.verbose) haxe.Log.trace(txt,{ fileName : "Ajax.hx", lineNumber : 103, className : "fovea.net.Ajax", methodName : "dtrace"});
};
fovea.net.Ajax.__super__ = fovea.events.Events;
fovea.net.Ajax.prototype = $extend(fovea.events.Events.prototype,{
	beforeAjax: function(options) {
	}
	,afterAjax: function(options,obj) {
	}
	,ajaxError: function(code,status,data,url) {
		if(status == null) status = 0;
		return new fovea.net.AjaxError(code,status,data,url);
	}
	,reqUrl: function(reqOptions) {
		return reqOptions.method + " " + reqOptions.host + ":" + reqOptions.port + "/" + reqOptions.path;
	}
	,prepareRequest: function(reqOptions,callback) {
		if(this.protocol == "https") {
			var reqsOptions = { host : reqOptions.host, port : reqOptions.port, path : reqOptions.path, method : reqOptions.method, headers : reqOptions.headers, ciphers : null, rejectUnauthorized : null};
			return (Https__1||require("https")).request(reqsOptions,callback);
		} else return (Http__5||require("http")).request(reqOptions,callback);
	}
	,ajax: function(method,path,options) {
		var _g = this;
		if(options == null) options = { };
		options.method = method;
		options.path = path;
		var deferred = new fovea.async.Deferred();
		var requestID;
		if(options.requestID != null) requestID = options.requestID; else requestID = StringTools.hex(Math.floor(Math.random() * 65535));
		options.requestID = requestID;
		fovea.net.Ajax.dtrace("AJAX[" + requestID + "] " + method + " " + this.url + path);
		this.beforeAjax(options);
		var data = "";
		if(options.data) data = JSON.stringify(options.data);
		var reqOptions = { host : this.host, port : this.port, path : this.path + (path.charAt(0) != "/"?"/":"") + path, method : method, headers : { 'Content-type' : "application/json", 'Content-Length' : data.length}};
		var req = this.prepareRequest(reqOptions,function(res) {
			var status = res.statusCode;
			var data1 = "";
			res.on("data",function(chunk) {
				data1 += chunk;
			});
			res.on("end",function() {
				fovea.net.Ajax.dtrace("AJAX[" + requestID + "] processing request");
				if(status >= 200 && status <= 299) {
					var json = null;
					try {
						if(data1 != "") json = JSON.parse(data1);
					} catch( err ) {
						fovea.net.Ajax.dtrace("[AJAX " + Std.string(options.requestID) + "] JSON parse error (" + data1 + ")");
						if(err.stack) fovea.net.Ajax.dtrace("[AJAX " + Std.string(options.requestID) + "] " + Std.string(err.stack)); else fovea.net.Ajax.dtrace("[AJAX " + Std.string(options.requestID) + "] " + Std.string(err));
						deferred.reject(_g.ajaxError("IO",1,data1,_g.reqUrl(reqOptions)));
						return;
					}
					var obj = { status : status, data : json};
					fovea.net.Ajax.dtrace("AJAX[" + Std.string(options.requestID) + "] done[" + status + "]: " + data1);
					_g.afterAjax(options,obj);
					deferred.resolve(obj);
					return;
				}
				deferred.reject(_g.ajaxError("HTTP",status,data1,_g.reqUrl(reqOptions)));
			});
		});
		req.on("error",function(error) {
			deferred.reject(_g.ajaxError("IO",0,error.message,_g.reqUrl(reqOptions)));
		});
		if(options.data) {
			req.write(data);
			fovea.net.Ajax.dtrace("AJAX[" + requestID + "] data=" + data);
		}
		req.end();
		return deferred;
	}
	,__class__: fovea.net.Ajax
});
fovea.ganomede = {};
fovea.ganomede.ApiClient = $hx_exports.fovea.ganomede.ApiClient = function(url) {
	this.pending = new haxe.ds.StringMap();
	this.cache = new haxe.ds.StringMap();
	fovea.net.Ajax.call(this,url);
};
fovea.ganomede.ApiClient.__name__ = true;
fovea.ganomede.ApiClient.__super__ = fovea.net.Ajax;
fovea.ganomede.ApiClient.prototype = $extend(fovea.net.Ajax.prototype,{
	clearCache: function() {
		this.cache = new haxe.ds.StringMap();
	}
	,service: function(type) {
		var separator = "/";
		if(this.url.length > 0 && this.url.charAt(this.url.length - 1) == "/") separator = "";
		if(type.length > 0 && type.charAt(0) == "/") separator = "";
		return new fovea.ganomede.ApiClient(this.url + separator + type);
	}
	,setCache: function(method,path,value) {
		var cacheID = method + ":" + path;
		this.cache.set(cacheID,value);
	}
	,cached: function(method,path) {
		var key = method + ":" + path;
		if(this.cache.exists(key)) return this.cache.get(method + ":" + path); else return null;
	}
	,setPending: function(method,path,deferred) {
		var _g = this;
		var key = method + ":" + path;
		this.pending.set(key,deferred);
		deferred.always(function() {
			_g.pending.remove(key);
		});
		return deferred;
	}
	,getPending: function(method,path) {
		var key = method + ":" + path;
		if(this.pending.exists(key)) return this.pending.get(key); else return null;
	}
	,cachedAjax: function(method,path,options) {
		if(options == null) options = { };
		var obj = this.cached(method,path);
		if(obj != null) {
			var deferred = new fovea.async.Deferred();
			deferred.resolve(obj);
			return deferred;
		}
		var pending = this.getPending(method,path);
		if(pending != null) return pending;
		return this.setPending(method,path,this.ajax(method,path,{ cache : true, parse : options.parse}));
	}
	,error: function(code,status,data) {
		if(status == null) status = 0;
		var p = new fovea.async.Deferred();
		var e = new fovea.ganomede.ApiError(code,status,data);
		p.reject(e);
		return p;
	}
	,ajaxError: function(code,status,data,url) {
		if(status == null) status = 0;
		return new fovea.ganomede.ApiError(code,status,data,url);
	}
	,beforeAjax: function(options) {
		if(options.cache) {
			options.cacheID = Std.string(options.method) + ":" + Std.string(options.path);
			if(fovea.net.Ajax.verbose) haxe.Log.trace("AJAX[" + Std.string(options.requestID) + "]: will cache",{ fileName : "ApiClient.hx", lineNumber : 106, className : "fovea.ganomede.ApiClient", methodName : "beforeAjax"});
		}
	}
	,afterAjax: function(options,obj) {
		if(options.parse) obj.data = options.parse(obj.data);
		if(options.cacheID) this.cache.set(options.cacheID,obj);
	}
	,ajaxGetData: function(path) {
		var deferred = new fovea.async.Deferred();
		this.ajax("GET",path).then(function(outcome) {
			if(outcome == null || outcome.data == null) deferred.reject(new fovea.ganomede.ApiError("IO")); else deferred.resolve(outcome.data);
		}).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,__class__: fovea.ganomede.ApiClient
});
var openfl = {};
openfl.errors = {};
openfl.errors.Error = function(message,id) {
	if(id == null) id = 0;
	if(message == null) message = "";
	this.message = message;
	this.errorID = id;
	this.name = "Error";
};
openfl.errors.Error.__name__ = true;
openfl.errors.Error.prototype = {
	getStackTrace: function() {
		return haxe.CallStack.toString(haxe.CallStack.exceptionStack());
	}
	,toString: function() {
		if(this.message != null) return this.message; else return "Error";
	}
	,__class__: openfl.errors.Error
};
fovea.net.AjaxError = $hx_exports.fovea.net.AjaxError = function(pcode,pstatus,pdata,purl) {
	if(pstatus == null) pstatus = 0;
	this.url = null;
	this.data = null;
	this.status = 0;
	this.code = null;
	var msg = "AjaxError[" + pcode + "]";
	if(pstatus != 0) msg += " status:" + pstatus;
	if(purl != null) msg += " url:" + purl;
	openfl.errors.Error.call(this,msg,1838012);
	this.code = pcode;
	this.status = pstatus;
	this.data = pdata;
	this.url = purl;
};
fovea.net.AjaxError.__name__ = true;
fovea.net.AjaxError.__super__ = openfl.errors.Error;
fovea.net.AjaxError.prototype = $extend(openfl.errors.Error.prototype,{
	__class__: fovea.net.AjaxError
});
fovea.ganomede.ApiError = $hx_exports.fovea.ganomede.ApiError = function(pcode,pstatus,pdata,purl) {
	if(pstatus == null) pstatus = 0;
	this.apiCode = null;
	this.apiMessage = null;
	fovea.net.AjaxError.call(this,pcode,pstatus,pdata,purl);
	if(this.data != null && this.data.message) this.apiMessage = this.data.message; else this.apiMessage = this.message;
	if(this.data != null && this.data.code) this.apiCode = this.data.code; else if(this.status != 0) this.apiCode = this.code + this.status; else this.apiCode = this.code;
};
fovea.ganomede.ApiError.__name__ = true;
fovea.ganomede.ApiError.__super__ = fovea.net.AjaxError;
fovea.ganomede.ApiError.prototype = $extend(fovea.net.AjaxError.prototype,{
	__class__: fovea.ganomede.ApiError
});
fovea.ganomede.AuthenticatedClient = $hx_exports.fovea.ganomede.AuthenticatedClient = function(baseUrl,type,token) {
	this.token = null;
	this.clientId = null;
	fovea.ganomede.ApiClient.call(this,baseUrl + "/" + type + "/auth/" + token);
	this.token = token;
	this.clientId = "" + Math.random() + "/" + Math.random();
};
fovea.ganomede.AuthenticatedClient.__name__ = true;
fovea.ganomede.AuthenticatedClient.__super__ = fovea.ganomede.ApiClient;
fovea.ganomede.AuthenticatedClient.prototype = $extend(fovea.ganomede.ApiClient.prototype,{
	__class__: fovea.ganomede.AuthenticatedClient
});
fovea.ganomede.Ganomede = $hx_exports.fovea.ganomede.Ganomede = function(url,options) {
	this.status = new fovea.utils.ReadyStatus();
	this.pool = new fovea.ganomede.GanomedeClientsPool();
	this.url = url;
	this.options = options;
};
fovea.ganomede.Ganomede.__name__ = true;
fovea.ganomede.Ganomede.prototype = {
	initialize: function() {
		var _g = this;
		return this.pool.initializeClient(this.url,this.options).then(function(result) {
			_g.client = result.client;
			_g.users = _g.client.users;
			_g.invitations = _g.client.invitations;
			_g.notifications = _g.client.notifications;
			_g.games = _g.client.games;
			_g.turngames = new fovea.ganomede.GanomedeTurnGamesComposite(_g.client,_g.pool);
			_g.avatars = _g.client.avatars;
			_g.chats = _g.client.chats;
			_g.virtualcurrency = _g.client.virtualcurrency;
			_g.statistics = _g.client.statistics;
			_g.data = _g.client.data;
			_g.challenges = _g.client.challenges;
			_g.status.setReady();
		});
	}
	,_fake: function() {
		var pr = null;
		var wf = null;
		var tgi = null;
		var tgim = null;
	}
	,ready: function() {
		return this.status.ready();
	}
	,__class__: fovea.ganomede.Ganomede
};
fovea.ganomede.GanomedeAvatars = $hx_exports.fovea.ganomede.GanomedeAvatars = function(client) {
	this.cdnHost = null;
	this.initialized = false;
	fovea.ganomede.ApiClient.call(this,client.url + "/" + "avatars/v1");
	this.client = client;
};
fovea.ganomede.GanomedeAvatars.__name__ = true;
fovea.ganomede.GanomedeAvatars.__super__ = fovea.ganomede.ApiClient;
fovea.ganomede.GanomedeAvatars.prototype = $extend(fovea.ganomede.ApiClient.prototype,{
	initialize: function() {
		var _g = this;
		return this.ajax("GET","/about").then(function(outcome) {
			var o = outcome.data;
			_g.initialized = true;
			if(o && o.config) {
				if(o.config.cdnHost) _g.cdnHost = o.config.cdnHost; else if(o.config.cdn) _g.cdnHost = o.config.cdn;
			}
		});
	}
	,user: function(username,version) {
		if(this.cdnHost != null) return "http://" + this.cdnHost + "/" + "avatars/v1" + "/" + username + "/" + version; else return this.url + "/" + username + "/" + version;
	}
	,my: function(version) {
		var username = this.client.users.me.username;
		return this.url + "/" + username + "/" + version + "?r=" + Math.random();
	}
	,__class__: fovea.ganomede.GanomedeAvatars
});
fovea.ganomede.UserClient = $hx_exports.fovea.ganomede.UserClient = function(client,clientFactory,type) {
	this.authClient = null;
	this.initialized = false;
	fovea.ganomede.ApiClient.call(this,client.url + (type != null?"/" + type:""));
	this.client = client;
	this.clientFactory = clientFactory;
	this.authClient = clientFactory(client.url,null);
};
fovea.ganomede.UserClient.__name__ = true;
fovea.ganomede.UserClient.__super__ = fovea.ganomede.ApiClient;
fovea.ganomede.UserClient.prototype = $extend(fovea.ganomede.ApiClient.prototype,{
	initialize: function() {
		var _g = this;
		var deferred = new fovea.async.Deferred();
		this.client.users.addEventListener("ganomede.login",$bind(this,this.onLoginLogout));
		this.client.users.addEventListener("ganomede.logout",$bind(this,this.onLoginLogout));
		this.client.users.addEventListener("ganomede.auth",$bind(this,this.onLoginLogout));
		deferred.resolve();
		return deferred.then(function(outcome) {
			_g.initialized = true;
			_g.dispatchEvent(new fovea.events.Event("change:initialize"));
		});
	}
	,executeAuth: function(f) {
		var _g = this;
		var cid0 = this.getClientID();
		var deferred = new fovea.async.Deferred();
		if(!this.isAuthOK()) return deferred;
		f().then(function(outcome) {
			if(cid0 == _g.getClientID() && _g.isAuthOK()) deferred.resolve(outcome);
		}).error(function(err) {
			if(cid0 == _g.getClientID() && _g.isAuthOK()) deferred.reject(err);
		});
		return deferred;
	}
	,getToken: function() {
		if(this.authClient != null) return this.authClient.token; else return null;
	}
	,getClientID: function() {
		if(this.authClient != null) return this.authClient.clientId; else return null;
	}
	,isAuthOK: function() {
		return this.getToken() != null && this.client.users.me.token == this.getToken();
	}
	,onLoginLogout: function(event) {
		var oldAuthToken = null;
		if(this.authClient != null) oldAuthToken = this.authClient.token;
		var newAuthToken = null;
		if(this.client.users.me != null) newAuthToken = this.client.users.me.token;
		if(newAuthToken != oldAuthToken) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("[UserClient] reset",{ fileName : "UserClient.hx", lineNumber : 88, className : "fovea.ganomede.UserClient", methodName : "onLoginLogout"});
			this.authClient = this.clientFactory(this.client.url,newAuthToken);
			this.dispatchEvent(new fovea.events.Event("reset"));
		}
	}
	,refreshCollection: function(collection,ajaxCall) {
		var deferred = new fovea.async.Deferred();
		if(this.authClient.token != null) this.executeAuth(ajaxCall).then(function(result) {
			if(collection.canMerge(result)) {
				collection.merge(result);
				deferred.resolve();
			} else deferred.reject(new fovea.ganomede.ApiError("IO",0,{ message : "Failed to merge response data into collection"}));
		}).error($bind(deferred,deferred.reject)); else {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("Can't load if not authenticated",{ fileName : "UserClient.hx", lineNumber : 112, className : "fovea.ganomede.UserClient", methodName : "refreshCollection"});
			deferred.reject(new fovea.ganomede.ApiError("CLIENT"));
		}
		return deferred;
	}
	,__class__: fovea.ganomede.UserClient
});
fovea.ganomede.GanomedeChallenges = $hx_exports.fovea.ganomede.GanomedeChallenges = function(client) {
	this.currentChallenge = new fovea.ganomede.models.GanomedeChallenge();
	this.collection = new fovea.utils.Collection();
	fovea.ganomede.UserClient.call(this,client,$bind(this,this.challengesClientFactory),"challenges/v1");
	var modelFactory = function(json) {
		return new fovea.ganomede.models.GanomedeChallenge(json);
	};
	this.collection.modelFactory = modelFactory;
	this.addEventListener("reset",$bind(this,this.onReset));
	this.collection.addEventListener("change",$bind(this,this.dispatchEvent));
};
fovea.ganomede.GanomedeChallenges.__name__ = true;
fovea.ganomede.GanomedeChallenges.__super__ = fovea.ganomede.UserClient;
fovea.ganomede.GanomedeChallenges.prototype = $extend(fovea.ganomede.UserClient.prototype,{
	asArray: function() {
		var array = this.collection.asArray();
		array.sort((function($this) {
			var $r;
			var arrayComparator = function(a,b) {
				return (js.Boot.__cast(a , fovea.ganomede.models.GanomedeChallenge)).start - (js.Boot.__cast(b , fovea.ganomede.models.GanomedeChallenge)).start | 0;
			};
			$r = arrayComparator;
			return $r;
		}(this)));
		return array;
	}
	,toJSON: function() {
		return this.collection.toJSON();
	}
	,current: function() {
		var _g = this;
		if(this.currentChallenge != null && this.currentChallenge.end >= new Date().getTime()) {
			var deferred = new fovea.async.Deferred();
			deferred.resolve(this.currentChallenge.toJSON());
			return deferred;
		}
		this.currentChallenge.reset();
		return (js.Boot.__cast(this.authClient , fovea.ganomede.GanomedeChallengesClient)).currentChallenge().then((function($this) {
			var $r;
			var currentChallengeLoaded = function(outcome) {
				if(outcome.data.id) {
					_g.currentChallenge.fromJSON(outcome.data);
					_g.adjustTimes(_g.currentChallenge);
				}
			};
			$r = currentChallengeLoaded;
			return $r;
		}(this)));
	}
	,postUserEntry: function(moves) {
		var _g = this;
		return fovea.async.Waterfall.run([$bind(this,this.current),function() {
			var client;
			client = js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeChallengesClient);
			return client.postUserEntry(_g.currentChallenge.id,moves);
		}]);
	}
	,getUserEntries: function() {
		var _g2 = this;
		var deferred = new fovea.async.Deferred();
		var client;
		client = js.Boot.__cast(this.authClient , fovea.ganomede.GanomedeChallengesClient);
		return client.getUserEntries().then((function($this) {
			var $r;
			var userEntriesGotten = function(outcome) {
				var array = outcome.data;
				var _g1 = 0;
				var _g = array.length;
				while(_g1 < _g) {
					var i = _g1++;
					array[i].username = _g2.client.users.me.username;
					array[i] = new fovea.ganomede.models.GanomedeChallengeEntry(array[i]);
				}
				deferred.resolve({ data : array});
			};
			$r = userEntriesGotten;
			return $r;
		}(this))).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,adjustTimes: function(data) {
		if(data == null) return;
		var now = new Date().getTime();
		var oldEnd = data.end;
		data.end = now + data.secondsToEnd * 1000 - 1;
		data.start = data.end - oldEnd + data.start;
	}
	,getLeaderboard: function(challengeId) {
		var deferred = new fovea.async.Deferred();
		(js.Boot.__cast(this.authClient , fovea.ganomede.GanomedeChallengesClient)).getLeaderboard(challengeId).then((function($this) {
			var $r;
			var getLeaderboardFn = function(outcome) {
				var array = outcome.data;
				var _g1 = 0;
				var _g = array.length;
				while(_g1 < _g) {
					var i = _g1++;
					array[i] = new fovea.ganomede.models.GanomedeChallengeEntry(array[i]);
					array[i].ranking = i + 1;
				}
				deferred.resolve({ entries : array});
			};
			$r = getLeaderboardFn;
			return $r;
		}(this))).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,challengesClientFactory: function(url,token) {
		return new fovea.ganomede.GanomedeChallengesClient(url,token);
	}
	,onReset: function(event) {
		this.collection.flushall();
		this.refreshArray();
	}
	,refreshArray: function() {
		var _g = this;
		return this.refreshCollection(this.collection,(function($this) {
			var $r;
			var arrayRefreshed = function() {
				return (js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeChallengesClient)).listChallenges();
			};
			$r = arrayRefreshed;
			return $r;
		}(this)));
	}
	,__class__: fovea.ganomede.GanomedeChallenges
});
fovea.ganomede.GanomedeChallengesClient = $hx_exports.fovea.ganomede.GanomedeChallengesClient = function(baseUrl,token) {
	fovea.ganomede.AuthenticatedClient.call(this,baseUrl,"challenges/v1",token);
};
fovea.ganomede.GanomedeChallengesClient.__name__ = true;
fovea.ganomede.GanomedeChallengesClient.__super__ = fovea.ganomede.AuthenticatedClient;
fovea.ganomede.GanomedeChallengesClient.prototype = $extend(fovea.ganomede.AuthenticatedClient.prototype,{
	listChallenges: function() {
		return this.ajax("GET","/challenges");
	}
	,currentChallenge: function() {
		return this.ajax("GET","/current");
	}
	,encodeURIComponent: function(s0) {
		var s1 = StringTools.replace(s0,"/","%2F");
		var s2 = StringTools.replace(s1,":","%3A");
		return s2;
	}
	,getLeaderboard: function(challengeId) {
		var id = this.encodeURIComponent(challengeId);
		return this.ajax("GET","/challenges/" + id + "/entries");
	}
	,getUserEntries: function() {
		return this.ajax("GET","/entries");
	}
	,postUserEntry: function(challengeId,moves) {
		var id = this.encodeURIComponent(challengeId);
		return this.ajax("POST","/challenges/" + id + "/entries",{ data : { authToken : this.token, moves : moves}});
	}
	,__class__: fovea.ganomede.GanomedeChallengesClient
});
fovea.ganomede.GanomedeChatClient = $hx_exports.fovea.ganomede.GanomedeChatClient = function(baseUrl,token) {
	fovea.ganomede.AuthenticatedClient.call(this,baseUrl,"chat/v1",token);
};
fovea.ganomede.GanomedeChatClient.__name__ = true;
fovea.ganomede.GanomedeChatClient.__super__ = fovea.ganomede.AuthenticatedClient;
fovea.ganomede.GanomedeChatClient.prototype = $extend(fovea.ganomede.AuthenticatedClient.prototype,{
	joinRoom: function(room) {
		return this.ajax("POST","/rooms",{ data : { type : room.type, users : room.users}}).then(function(result) {
			if(result.data.id) room.fromJSON(result.data);
		});
	}
	,encodeURIComponent: function(s) {
		return StringTools.replace(s,"/","%2F");
	}
	,loadRoom: function(room) {
		return this.ajax("GET","/rooms/" + this.encodeURIComponent(room.id)).then(function(result) {
			if(result.data.id) room.fromJSON(result.data);
		});
	}
	,postMessage: function(room,message) {
		return this.ajax("POST","/rooms/" + this.encodeURIComponent(room.id) + "/messages",{ data : this.messageDataWithPush(message)});
	}
	,messageDataWithPush: function(message) {
		var data = message.toJSON();
		data.push = { app : message.type, title : ["new_message_title",message.from], titleArgsTypes : ["directory:name"], message : ["new_message_message",message.message,message.from], messageArgsTypes : ["string","directory:name"]};
		return data;
	}
	,__class__: fovea.ganomede.GanomedeChatClient
});
fovea.ganomede.GanomedeChatEvent = $hx_exports.fovea.ganomede.GanomedeChatEvent = function(n) {
	fovea.events.Event.call(this,n.type);
	this.room = n;
};
fovea.ganomede.GanomedeChatEvent.__name__ = true;
fovea.ganomede.GanomedeChatEvent.__super__ = fovea.events.Event;
fovea.ganomede.GanomedeChatEvent.prototype = $extend(fovea.events.Event.prototype,{
	__class__: fovea.ganomede.GanomedeChatEvent
});
fovea.ganomede.GanomedeChats = $hx_exports.fovea.ganomede.GanomedeChats = function(client) {
	this.collection = new fovea.utils.Collection();
	fovea.ganomede.UserClient.call(this,client,$bind(this,this.chatClientFactory),"chat/v1");
	var modelFactory = function(json) {
		return new fovea.ganomede.models.GanomedeChatRoom(json);
	};
	this.collection.modelFactory = modelFactory;
	this.addEventListener("reset",$bind(this,this.onReset));
	this.collection.addEventListener("change",$bind(this,this.dispatchEvent));
	if(client.notifications != null) client.notifications.listenTo("chat/v1",$bind(this,this.onChat));
};
fovea.ganomede.GanomedeChats.__name__ = true;
fovea.ganomede.GanomedeChats.__super__ = fovea.ganomede.UserClient;
fovea.ganomede.GanomedeChats.prototype = $extend(fovea.ganomede.UserClient.prototype,{
	asArray: function() {
		var array = this.collection.asArray();
		array.sort((function($this) {
			var $r;
			var arrayComparator = function(a,b) {
				var $as = (js.Boot.__cast(a , fovea.ganomede.models.GanomedeChatRoom)).id;
				var bs = (js.Boot.__cast(b , fovea.ganomede.models.GanomedeChatRoom)).id;
				if($as < bs) return -1;
				if($as > bs) return 1;
				return 0;
			};
			$r = arrayComparator;
			return $r;
		}(this)));
		return array;
	}
	,toJSON: function() {
		return this.collection.toJSON();
	}
	,onChat: function(event) {
		var e = event;
		var data = e.notification.data;
		if(data != null && data.roomId != null) {
			var room = this.collection.get(data.roomId);
			var msg = { timestamp : data.timestamp, from : data.from, type : data.type, message : data.message};
			if(room == null) room = new fovea.ganomede.models.GanomedeChatRoom({ id : data.roomId, type : data.roomId.split("/").slice(0,2).join("/"), users : [this.client.users.me.username,data.from], messages : []});
			room.messages.unshift(new fovea.ganomede.models.GanomedeChatMessage(msg));
			this.dispatchEvent(new fovea.ganomede.GanomedeChatEvent(room));
		}
	}
	,chatClientFactory: function(url,token) {
		return new fovea.ganomede.GanomedeChatClient(url,token);
	}
	,onReset: function(event) {
		this.collection.flushall();
	}
	,join: function(room) {
		var _g = this;
		if(!this.client.users.me.isAuthenticated()) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("cant join chat room: not authenticated",{ fileName : "GanomedeChats.hx", lineNumber : 81, className : "fovea.ganomede.GanomedeChats", methodName : "join"});
			return this.error("CLIENT");
		}
		if(room.type == null) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("cant join chat room: missing type",{ fileName : "GanomedeChats.hx", lineNumber : 85, className : "fovea.ganomede.GanomedeChats", methodName : "join"});
			return this.error("CLIENT");
		}
		if(room.users == null || room.users.length == 0) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("cant join chat room: no users",{ fileName : "GanomedeChats.hx", lineNumber : 89, className : "fovea.ganomede.GanomedeChats", methodName : "join"});
			return this.error("CLIENT");
		}
		return this.executeAuth((function($this) {
			var $r;
			var joinRoomFn = function() {
				var chatClient = _g.authClient;
				return chatClient.joinRoom(room);
			};
			$r = joinRoomFn;
			return $r;
		}(this))).then((function($this) {
			var $r;
			var roomJoined = function(outcome) {
				_g.collection.merge(room.toJSON());
			};
			$r = roomJoined;
			return $r;
		}(this)));
	}
	,postMessage: function(room,message) {
		var _g = this;
		room.messages.unshift(message);
		return this.executeAuth((function($this) {
			var $r;
			var postMessageFn = function() {
				var chatClient = _g.authClient;
				return chatClient.postMessage(room,message);
			};
			$r = postMessageFn;
			return $r;
		}(this)));
	}
	,__class__: fovea.ganomede.GanomedeChats
});
fovea.ganomede.GanomedeClient = $hx_exports.fovea.ganomede.GanomedeClient = function(url,options) {
	this.options = { };
	this.initialized = false;
	fovea.ganomede.ApiClient.call(this,url);
	this.options = options;
	if(!options) this.options = options = { };
	if(!options.games) options.games = { };
	if(!options.notifications) options.notifications = { };
	if(!options.invitations) options.invitations = { };
	if(!options.users) options.users = { };
	if(!options.turngames) options.turngames = { };
	if(!options.avatars) options.avatars = { };
	if(!options.chats) options.chats = { };
	if(!options.virtualcurrency) options.virtualcurrency = { };
	if(!options.statistics) options.statistics = { };
	if(!options.data) options.data = { };
	if(!options.challenges) options.challenges = { };
	if(options.users.enabled) this.users = new fovea.ganomede.GanomedeUsers(this);
	if(options.notifications.enabled) this.notifications = new fovea.ganomede.GanomedeNotifications(this);
	if(options.invitations.enabled) this.invitations = new fovea.ganomede.GanomedeInvitations(this);
	if(options.games.enabled) this.games = new fovea.ganomede.GanomedeGames(this,options.games.type);
	if(options.turngames.enabled) this.turngames = new fovea.ganomede.GanomedeTurnGames(this);
	if(options.avatars.enabled) this.avatars = new fovea.ganomede.GanomedeAvatars(this);
	if(options.chats.enabled) this.chats = new fovea.ganomede.GanomedeChats(this);
	if(options.virtualcurrency.enabled) this.virtualcurrency = new fovea.ganomede.GanomedeVirtualCurrency(this);
	if(options.statistics.enabled) this.statistics = new fovea.ganomede.GanomedeStatistics(this,options.games.type);
	if(options.data.enabled) this.data = new fovea.ganomede.GanomedeData(this);
	if(options.challenges.enabled) this.challenges = new fovea.ganomede.GanomedeChallenges(this);
};
fovea.ganomede.GanomedeClient.__name__ = true;
fovea.ganomede.GanomedeClient.__super__ = fovea.ganomede.ApiClient;
fovea.ganomede.GanomedeClient.prototype = $extend(fovea.ganomede.ApiClient.prototype,{
	initialize: function() {
		var _g = this;
		var a = [];
		if(this.users != null) a.push(($_=this.users,$bind($_,$_.initialize)));
		if(this.invitations != null) a.push(($_=this.invitations,$bind($_,$_.initialize)));
		if(this.notifications != null) a.push(($_=this.notifications,$bind($_,$_.initialize)));
		if(this.games != null) a.push(($_=this.games,$bind($_,$_.initialize)));
		if(this.turngames != null) a.push(($_=this.turngames,$bind($_,$_.initialize)));
		if(this.avatars != null) a.push(($_=this.avatars,$bind($_,$_.initialize)));
		if(this.chats != null) a.push(($_=this.chats,$bind($_,$_.initialize)));
		if(this.virtualcurrency != null) a.push(($_=this.virtualcurrency,$bind($_,$_.initialize)));
		if(this.statistics != null) a.push(($_=this.statistics,$bind($_,$_.initialize)));
		if(this.data != null) a.push(($_=this.data,$bind($_,$_.initialize)));
		if(this.challenges != null) a.push(($_=this.challenges,$bind($_,$_.initialize)));
		return fovea.async.Parallel.run(a).then(function(outcome) {
			_g.initialized = true;
		});
	}
	,__class__: fovea.ganomede.GanomedeClient
});
fovea.ganomede.GanomedeClientsPool = $hx_exports.fovea.ganomede.GanomedeClientsPool = function() {
	this.array = new Array();
	this.pool = new haxe.ds.StringMap();
};
fovea.ganomede.GanomedeClientsPool.__name__ = true;
fovea.ganomede.GanomedeClientsPool.prototype = {
	initializeClient: function(url,options) {
		var _g = this;
		var key = url;
		var deferred = new fovea.async.Deferred();
		if(!this.pool.exists(key)) {
			var client = new fovea.ganomede.GanomedeClient(url,options);
			client.initialize().then(function(outcome) {
				var id = _g.array.length;
				_g.array.push(client);
				_g.pool.set(key,id);
				deferred.resolve({ id : id, client : client});
			}).error(function(err) {
				deferred.reject(err);
			});
		} else {
			var id1 = this.pool.get(key);
			deferred.resolve({ id : id1, client : this.getClient(id1)});
		}
		return deferred;
	}
	,getClient: function(id) {
		return this.array[id];
	}
	,__class__: fovea.ganomede.GanomedeClientsPool
};
fovea.ganomede.GanomedeCoordinatorClient = $hx_exports.fovea.ganomede.GanomedeCoordinatorClient = function(baseUrl,token) {
	fovea.ganomede.AuthenticatedClient.call(this,baseUrl,"coordinator/v1",token);
};
fovea.ganomede.GanomedeCoordinatorClient.__name__ = true;
fovea.ganomede.GanomedeCoordinatorClient.__super__ = fovea.ganomede.AuthenticatedClient;
fovea.ganomede.GanomedeCoordinatorClient.prototype = $extend(fovea.ganomede.AuthenticatedClient.prototype,{
	addGame: function(game) {
		return this.ajax("POST","/" + game.type + "/games",{ data : { players : game.players}}).then(function(result) {
			if(result.data.id) game.fromJSON(result.data);
		});
	}
	,getGame: function() {
		return this.ajax("GET","/game");
	}
	,activeGames: function(type) {
		return this.ajax("GET","/" + type + "/active-games");
	}
	,leaveGame: function(game) {
		return this.ajax("POST","/games/" + game.id + "/leave").then(function(result) {
			if(result.data.id) game.fromJSON(result.data);
		});
	}
	,joinGame: function(game) {
		return this.ajax("POST","/games/" + game.id + "/join").then(function(result) {
			if(result.data.id) game.fromJSON(result.data);
		});
	}
	,gameover: function(game,gameOverData) {
		return this.ajax("POST","/games/" + game.id + "/gameover",{ data : { gameOverData : gameOverData}}).then(function(result) {
			if(result.data.id) game.fromJSON(result.data);
		});
	}
	,__class__: fovea.ganomede.GanomedeCoordinatorClient
});
fovea.ganomede.GanomedeData = $hx_exports.fovea.ganomede.GanomedeData = function(client) {
	fovea.ganomede.ApiClient.call(this,client.url + "/" + "data/v1");
};
fovea.ganomede.GanomedeData.__name__ = true;
fovea.ganomede.GanomedeData.__super__ = fovea.ganomede.ApiClient;
fovea.ganomede.GanomedeData.prototype = $extend(fovea.ganomede.ApiClient.prototype,{
	initialize: function() {
		return new fovea.async.Deferred().resolve(null);
	}
	,getData: function(docName) {
		return this.ajaxGetData("/docs/" + docName);
	}
	,__class__: fovea.ganomede.GanomedeData
});
fovea.ganomede.GanomedeEvents = $hx_exports.fovea.ganomede.GanomedeEvents = function() { };
fovea.ganomede.GanomedeEvents.__name__ = true;
fovea.ganomede.GanomedeGames = $hx_exports.fovea.ganomede.GanomedeGames = function(client,type) {
	this.collection = new fovea.utils.Collection();
	fovea.ganomede.UserClient.call(this,client,$bind(this,this.coordinatorClientFactory));
	this.collection.keepStrategy = function(game) {
		return (js.Boot.__cast(game , fovea.ganomede.models.GanomedeGame)).status == "active";
	};
	this.collection.modelFactory = function(json) {
		return new fovea.ganomede.models.GanomedeGame(json);
	};
	this.type = type;
	this.addEventListener("reset",$bind(this,this.onReset));
	this.collection.addEventListener("change",$bind(this,this.dispatchEvent));
};
fovea.ganomede.GanomedeGames.__name__ = true;
fovea.ganomede.GanomedeGames.__super__ = fovea.ganomede.UserClient;
fovea.ganomede.GanomedeGames.prototype = $extend(fovea.ganomede.UserClient.prototype,{
	asArray: function() {
		var array = this.collection.asArray();
		array.sort(function(a,b) {
			if(a.id > b.id) return 1; else return -1;
		});
		return array;
	}
	,toJSON: function() {
		return this.collection.toJSON();
	}
	,coordinatorClientFactory: function(url,token) {
		return new fovea.ganomede.GanomedeCoordinatorClient(url,token);
	}
	,onReset: function(event) {
		if(fovea.net.Ajax.verbose) haxe.Log.trace("reset!",{ fileName : "GanomedeGames.hx", lineNumber : 47, className : "fovea.ganomede.GanomedeGames", methodName : "onReset"});
		this.collection.flushall();
		this.refreshArray();
	}
	,add: function(game) {
		var _g = this;
		if(!this.client.users.me.isAuthenticated()) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("cant add game: not authenticated",{ fileName : "GanomedeGames.hx", lineNumber : 54, className : "fovea.ganomede.GanomedeGames", methodName : "add"});
			return this.error("CLIENT");
		}
		return this.executeAuth(function() {
			return (js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeCoordinatorClient)).addGame(game);
		}).then(function(outcome) {
			_g.collection.merge(game.toJSON());
		});
	}
	,join: function(game) {
		var _g = this;
		return this.executeAuth(function() {
			return (js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeCoordinatorClient)).joinGame(game);
		}).then(function(outcome) {
			_g.collection.merge(game.toJSON());
		});
	}
	,leave: function(game) {
		var _g = this;
		return this.executeAuth(function() {
			return (js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeCoordinatorClient)).leaveGame(game);
		}).then(function(outcome) {
			_g.collection.merge(game.toJSON());
		});
	}
	,gameover: function(game,gameOverData) {
		var _g = this;
		return this.executeAuth(function() {
			return (js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeCoordinatorClient)).gameover(game,gameOverData);
		}).then(function(outcome) {
			_g.collection.merge(game.toJSON());
		});
	}
	,refreshArray: function() {
		var _g = this;
		return this.refreshCollection(this.collection,function() {
			return (js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeCoordinatorClient)).activeGames(_g.type).then(function(outcome) {
				if(outcome == null) return;
				if(outcome.data == null) return;
				var array;
				array = js.Boot.__cast(outcome.data , Array);
				if(array != null) {
					var _g2 = 0;
					var _g1 = array.length;
					while(_g2 < _g1) {
						var i = _g2++;
						array[i].status = "active";
					}
				}
			});
		});
	}
	,__class__: fovea.ganomede.GanomedeGames
});
fovea.ganomede.GanomedeInvitations = $hx_exports.fovea.ganomede.GanomedeInvitations = function(client) {
	this.collection = new fovea.utils.Collection();
	var _g = this;
	fovea.ganomede.UserClient.call(this,client,$bind(this,this.invitationsClientFactory),"invitations/v1");
	var modelFactory = function(json) {
		return new fovea.ganomede.models.GanomedeInvitation(json);
	};
	this.collection.modelFactory = modelFactory;
	this.addEventListener("reset",$bind(this,this.onReset));
	this.collection.addEventListener("change",$bind(this,this.dispatchEvent));
	if(client.notifications != null) client.notifications.listenTo("invitations/v1",(function($this) {
		var $r;
		var invitationNotification = function(event) {
			_g.refreshArray();
		};
		$r = invitationNotification;
		return $r;
	}(this)));
};
fovea.ganomede.GanomedeInvitations.__name__ = true;
fovea.ganomede.GanomedeInvitations.__super__ = fovea.ganomede.UserClient;
fovea.ganomede.GanomedeInvitations.prototype = $extend(fovea.ganomede.UserClient.prototype,{
	asArray: function() {
		var array = this.collection.asArray();
		array.sort((function($this) {
			var $r;
			var arrayComparator = function(a,b) {
				return (js.Boot.__cast(a , fovea.ganomede.models.GanomedeInvitation)).index - (js.Boot.__cast(b , fovea.ganomede.models.GanomedeInvitation)).index;
			};
			$r = arrayComparator;
			return $r;
		}(this)));
		return array;
	}
	,toJSON: function() {
		return this.collection.toJSON();
	}
	,invitationsClientFactory: function(url,token) {
		return new fovea.ganomede.GanomedeInvitationsClient(url,token);
	}
	,onReset: function(event) {
		this.collection.flushall();
		this.refreshArray();
	}
	,add: function(invitation) {
		var _g = this;
		if(!this.client.users.me.isAuthenticated()) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("cant add invitation: not authenticated",{ fileName : "GanomedeInvitations.hx", lineNumber : 53, className : "fovea.ganomede.GanomedeInvitations", methodName : "add"});
			return this.error("CLIENT");
		}
		invitation.from = this.client.users.me.username;
		return this.executeAuth((function($this) {
			var $r;
			var addInvitationFn = function() {
				var invitationsClient = _g.authClient;
				return invitationsClient.addInvitation(invitation);
			};
			$r = addInvitationFn;
			return $r;
		}(this))).then((function($this) {
			var $r;
			var invitationAdded = function(outcome) {
				_g.collection.merge(invitation.toJSON());
			};
			$r = invitationAdded;
			return $r;
		}(this)));
	}
	,cancel: function(invitation) {
		return this.deleteInvitation(invitation,"cancel");
	}
	,accept: function(invitation) {
		return this.deleteInvitation(invitation,"accept");
	}
	,refuse: function(invitation) {
		return this.deleteInvitation(invitation,"refuse");
	}
	,deleteInvitation: function(invitation,reason) {
		var _g = this;
		var deferred = new fovea.async.Deferred();
		this.executeAuth((function($this) {
			var $r;
			var deleteInvitationFn = function() {
				var invitationsClient = _g.authClient;
				return invitationsClient.deleteInvitation(invitation,reason);
			};
			$r = deleteInvitationFn;
			return $r;
		}(this))).then((function($this) {
			var $r;
			var invitationDeleted = function(outcome) {
				_g.collection.del(invitation.id);
				_g.dispatchEvent(new fovea.events.Event("change"));
				deferred.resolve();
			};
			$r = invitationDeleted;
			return $r;
		}(this))).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,refreshArray: function() {
		var _g = this;
		return this.refreshCollection(this.collection,(function($this) {
			var $r;
			var arrayRefreshed = function() {
				return (js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeInvitationsClient)).listInvitations();
			};
			$r = arrayRefreshed;
			return $r;
		}(this)));
	}
	,__class__: fovea.ganomede.GanomedeInvitations
});
fovea.ganomede.GanomedeInvitationsClient = $hx_exports.fovea.ganomede.GanomedeInvitationsClient = function(baseUrl,token) {
	fovea.ganomede.AuthenticatedClient.call(this,baseUrl,"invitations/v1",token);
};
fovea.ganomede.GanomedeInvitationsClient.__name__ = true;
fovea.ganomede.GanomedeInvitationsClient.__super__ = fovea.ganomede.AuthenticatedClient;
fovea.ganomede.GanomedeInvitationsClient.prototype = $extend(fovea.ganomede.AuthenticatedClient.prototype,{
	addInvitation: function(invitation) {
		return this.ajax("POST","/invitations",{ data : { gameId : invitation.gameId, type : invitation.type, to : invitation.to}}).then((function($this) {
			var $r;
			var invitationAdded = function(result) {
				if(result.data.id) invitation.id = result.data.id;
			};
			$r = invitationAdded;
			return $r;
		}(this)));
	}
	,listInvitations: function() {
		return this.ajax("GET","/invitations");
	}
	,deleteInvitation: function(invite,reason) {
		var deferred = new fovea.async.Deferred();
		this.ajax("POST","/invitations/" + invite.id + "/delete",{ data : { reason : reason}}).then((function($this) {
			var $r;
			var invitationDeleted = function(result) {
				if(!result.data || result.data.ok == true) deferred.resolve(); else deferred.reject(new fovea.ganomede.ApiError("HTTP",result.status,result.data));
			};
			$r = invitationDeleted;
			return $r;
		}(this))).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,__class__: fovea.ganomede.GanomedeInvitationsClient
});
fovea.ganomede.GanomedeNotification = $hx_exports.fovea.ganomede.GanomedeNotification = function(obj) {
	if(obj) this.fromJSON(obj);
};
fovea.ganomede.GanomedeNotification.__name__ = true;
fovea.ganomede.GanomedeNotification.prototype = {
	equals: function(obj) {
		if(obj.id != this.id) return false;
		if(obj.type != this.type) return false;
		if(obj.to != this.to) return false;
		if(obj.from != this.from) return false;
		return true;
	}
	,fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.id) this.id = obj.id;
		if(obj.type) this.type = obj.type;
		if(obj.to) this.to = obj.to;
		if(obj.from) this.from = obj.from;
		if(obj.timestamp) this.timestamp = obj.timestamp;
		if(obj.data) this.data = obj.data;
		if(obj.push) this.push = obj.push;
	}
	,toJSON: function() {
		return { id : this.id, type : this.type, to : this.to, from : this.from, timestamp : this.timestamp, data : this.data, push : this.push};
	}
	,__class__: fovea.ganomede.GanomedeNotification
};
fovea.ganomede.GanomedeNotificationEvent = $hx_exports.fovea.ganomede.GanomedeNotificationEvent = function(n) {
	fovea.events.Event.call(this,n.from);
	this.notification = n;
};
fovea.ganomede.GanomedeNotificationEvent.__name__ = true;
fovea.ganomede.GanomedeNotificationEvent.__super__ = fovea.events.Event;
fovea.ganomede.GanomedeNotificationEvent.prototype = $extend(fovea.events.Event.prototype,{
	__class__: fovea.ganomede.GanomedeNotificationEvent
});
fovea.ganomede.GanomedeNotifications = $hx_exports.fovea.ganomede.GanomedeNotifications = function(client) {
	this.online = [];
	this.apiSecret = "";
	this.lastId = -1;
	this.keepPolling = true;
	fovea.ganomede.UserClient.call(this,client,$bind(this,this.notificationsClientFactory),"notifications/v1");
	this.addEventListener("change:initialize",$bind(this,this.onInitialize));
	this.addEventListener("reset",$bind(this,this.onReset));
};
fovea.ganomede.GanomedeNotifications.__name__ = true;
fovea.ganomede.GanomedeNotifications.__super__ = fovea.ganomede.UserClient;
fovea.ganomede.GanomedeNotifications.prototype = $extend(fovea.ganomede.UserClient.prototype,{
	stopPolling: function() {
		this.keepPolling = false;
	}
	,startPolling: function() {
		this.keepPolling = true;
	}
	,notificationsClientFactory: function(url,token) {
		return new fovea.ganomede.GanomedeNotificationsClient(url,token);
	}
	,listenTo: function(emiter,callback) {
		this.on(emiter,callback);
	}
	,onPollSuccess: function(result) {
		try {
			var notifClient = this.authClient;
			var notifications;
			notifications = js.Boot.__cast(result.data , Array);
			if(fovea.net.Ajax.verbose) haxe.Log.trace("[GanomedeNotifications] results for " + Std.string(result.token),{ fileName : "GanomedeNotifications.hx", lineNumber : 44, className : "fovea.ganomede.GanomedeNotifications", methodName : "onPollSuccess"});
			if(notifications == null || result.token != notifClient.token || result.clientId != notifClient.clientId) {
				if(fovea.net.Ajax.verbose && notifications != null) haxe.Log.trace("skip",{ fileName : "GanomedeNotifications.hx", lineNumber : 47, className : "fovea.ganomede.GanomedeNotifications", methodName : "onPollSuccess"});
				haxe.Timer.delay($bind(this,this.poll),100);
				return;
			}
			var _g1 = 0;
			var _g = notifications.length;
			while(_g1 < _g) {
				var i = _g1++;
				var n = notifications[notifications.length - i - 1];
				if(n.id > this.lastId) this.lastId = n.id;
				if(!result.silent) this.dispatchNotification(n);
			}
		} catch( error ) {
			if( js.Boot.__instanceof(error,String) ) {
				if(fovea.net.Ajax.verbose) haxe.Log.trace("[GanomedeNotifications] ERROR " + error,{ fileName : "GanomedeNotifications.hx", lineNumber : 60, className : "fovea.ganomede.GanomedeNotifications", methodName : "onPollSuccess"});
			} else throw(error);
		}
		haxe.Timer.delay($bind(this,this.poll),100);
	}
	,onPollError: function(error) {
		haxe.Timer.delay($bind(this,this.poll),1000);
	}
	,poll: function() {
		var _g = this;
		if(!this.keepPolling) {
			haxe.Timer.delay($bind(this,this.poll),1000);
			return;
		}
		var notifClient = this.authClient;
		if(!notifClient.polling) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("[GanomedeNotifications] poll",{ fileName : "GanomedeNotifications.hx", lineNumber : 74, className : "fovea.ganomede.GanomedeNotifications", methodName : "poll"});
			this.executeAuth(function() {
				return notifClient.poll(_g.lastId);
			}).then($bind(this,this.onPollSuccess)).error($bind(this,this.onPollError));
		}
	}
	,silentPoll: function() {
		var _g = this;
		var notifClient = this.authClient;
		if(this.isAuthOK()) this.executeAuth(function() {
			return notifClient.poll(-2);
		}).then(function(result) {
			result.silent = true;
			_g.onPollSuccess(result);
		}).error(function(err) {
			haxe.Timer.delay($bind(_g,_g.silentPoll),1000);
		}); else haxe.Timer.delay($bind(this,this.silentPoll),1000);
	}
	,onInitialize: function(event) {
		this.silentPoll();
		var timer = new haxe.Timer(60000);
		timer.run = $bind(this,this.poll);
	}
	,onReset: function(event) {
		this.lastId = -1;
		this.silentPoll();
	}
	,dispatchNotification: function(n) {
		if(fovea.net.Ajax.verbose) haxe.Log.trace("[GanomedeNotifications] notification: " + JSON.stringify(n.toJSON()),{ fileName : "GanomedeNotifications.hx", lineNumber : 114, className : "fovea.ganomede.GanomedeNotifications", methodName : "dispatchNotification"});
		this.dispatchEvent(new fovea.ganomede.GanomedeNotificationEvent(n));
	}
	,send: function(n) {
		var data = n.toJSON();
		data.secret = this.apiSecret;
		return this.ajax("POST","/messages",{ data : data});
	}
	,refreshOnline: function(tag) {
		var _g = this;
		if(fovea.net.Ajax.verbose) haxe.Log.trace("[GanomedeNotifications] refreshOnline(" + tag + ")",{ fileName : "GanomedeNotifications.hx", lineNumber : 129, className : "fovea.ganomede.GanomedeNotifications", methodName : "refreshOnline"});
		var method = "GET";
		var endpoint = "/online";
		if(tag != null) endpoint = endpoint + "/" + tag;
		var postSupported = true;
		if(this.client.users.me != null && postSupported) {
			var token = this.client.users.me.token;
			if(token != null) {
				method = "POST";
				endpoint = "/auth/" + token + "/online";
				if(tag != null) endpoint = endpoint + "/" + tag;
			}
		}
		return this.ajax(method,endpoint).then(function(outcome) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("[GanomedeNotifications] online.then(): " + JSON.stringify(outcome),{ fileName : "GanomedeNotifications.hx", lineNumber : 156, className : "fovea.ganomede.GanomedeNotifications", methodName : "refreshOnline"});
			_g.online = outcome.data;
		});
	}
	,lastSeen: function(usernames) {
		if(fovea.net.Ajax.verbose) haxe.Log.trace("[GanomedeNotifications] lastSeen(" + JSON.stringify(usernames) + ")",{ fileName : "GanomedeNotifications.hx", lineNumber : 162, className : "fovea.ganomede.GanomedeNotifications", methodName : "lastSeen"});
		return this.ajax("GET","/lastseen/" + usernames.join(",")).then(function(outcome) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("[GanomedeNotifications] lastSeen.then(): " + JSON.stringify(outcome),{ fileName : "GanomedeNotifications.hx", lineNumber : 165, className : "fovea.ganomede.GanomedeNotifications", methodName : "lastSeen"});
		});
	}
	,savePushToken: function(pushToken) {
		if(this.client.users.me != null) {
			var token = this.client.users.me.token;
			var endpoint = "/auth/" + token + "/push-token";
			return this.ajax("POST",endpoint,{ data : pushToken.toJSON()});
		} else return new fovea.async.Deferred().reject(new openfl.errors.Error("Not authenticated"));
	}
	,__class__: fovea.ganomede.GanomedeNotifications
});
fovea.ganomede.GanomedeNotificationsClient = $hx_exports.fovea.ganomede.GanomedeNotificationsClient = function(baseUrl,token) {
	this.polling = false;
	fovea.ganomede.AuthenticatedClient.call(this,baseUrl,"notifications/v1",token);
};
fovea.ganomede.GanomedeNotificationsClient.__name__ = true;
fovea.ganomede.GanomedeNotificationsClient.__super__ = fovea.ganomede.AuthenticatedClient;
fovea.ganomede.GanomedeNotificationsClient.prototype = $extend(fovea.ganomede.AuthenticatedClient.prototype,{
	poll: function(after) {
		if(this.polling) {
			var deferred = new fovea.async.Deferred();
			return deferred;
		}
		this.polling = true;
		var uri = fovea.net.UrlFormatter.format("/messages",{ after : after});
		return this.ajax("GET",uri,{ parse : $bind(this,this.parseArray), silentIOError : true}).then($bind(this,this.pollSuccess)).error($bind(this,this.pollError));
	}
	,online: function() {
		return this.ajax("GET","/online");
	}
	,pollSuccess: function(outcome) {
		outcome.token = this.token;
		outcome.clientId = this.clientId;
		this.polling = false;
	}
	,pollError: function(error) {
		this.polling = false;
	}
	,parseArray: function(obj) {
		var array;
		array = js.Boot.__cast(obj , Array);
		if(array == null) return obj;
		var i;
		var _g1 = 0;
		var _g = array.length;
		while(_g1 < _g) {
			var i1 = _g1++;
			array[i1] = new fovea.ganomede.GanomedeNotification(array[i1]);
		}
		return array;
	}
	,__class__: fovea.ganomede.GanomedeNotificationsClient
});
fovea.ganomede.GanomedeStatistics = $hx_exports.fovea.ganomede.GanomedeStatistics = function(client,gameType) {
	fovea.ganomede.ApiClient.call(this,client.url + "/" + "statistics/v1" + "/" + gameType);
};
fovea.ganomede.GanomedeStatistics.__name__ = true;
fovea.ganomede.GanomedeStatistics.makePath = function(username,endpoint) {
	return "/" + username + "/" + endpoint;
};
fovea.ganomede.GanomedeStatistics.__super__ = fovea.ganomede.ApiClient;
fovea.ganomede.GanomedeStatistics.prototype = $extend(fovea.ganomede.ApiClient.prototype,{
	initialize: function() {
		return new fovea.async.Deferred().resolve(null);
	}
	,getRank: function(username) {
		return this.ajaxGetData(fovea.ganomede.GanomedeStatistics.makePath(username,"rank"));
	}
	,getLevel: function(username) {
		return this.ajaxGetData(fovea.ganomede.GanomedeStatistics.makePath(username,"level"));
	}
	,getArchive: function(username) {
		var deferred = new fovea.async.Deferred();
		this.ajaxGetData(fovea.ganomede.GanomedeStatistics.makePath(username,"archive")).then(function(obj) {
			deferred.resolve(fovea.ganomede.models.GanomedeGameArchive.fromJSON(obj));
		}).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,__class__: fovea.ganomede.GanomedeStatistics
});
fovea.ganomede.GanomedeTurnGameClient = $hx_exports.fovea.ganomede.GanomedeTurnGameClient = function(baseUrl,token) {
	fovea.ganomede.AuthenticatedClient.call(this,baseUrl,"turngame/v1",token);
};
fovea.ganomede.GanomedeTurnGameClient.__name__ = true;
fovea.ganomede.GanomedeTurnGameClient.__super__ = fovea.ganomede.AuthenticatedClient;
fovea.ganomede.GanomedeTurnGameClient.prototype = $extend(fovea.ganomede.AuthenticatedClient.prototype,{
	getGame: function(game) {
		if(game.id == null) {
			var deferred = new fovea.async.Deferred();
			deferred.reject(new fovea.ganomede.ApiError("HTTP",400));
			return deferred;
		}
		return this.ajax("GET","/games/" + game.id).then(function(result) {
			game.fromJSON(result.data);
		});
	}
	,addGame: function(game) {
		if(game.id == null) {
			var deferred = new fovea.async.Deferred();
			deferred.reject(new fovea.ganomede.ApiError("HTTP",400));
			return deferred;
		}
		return this.ajax("POST","/games/" + game.id,{ data : game.toJSON()}).then(function(result) {
			game.fromJSON(result.data);
		});
	}
	,addMove: function(game,move) {
		if(game.id == null) {
			var deferred = new fovea.async.Deferred();
			deferred.reject(new fovea.ganomede.ApiError("HTTP",400));
			return deferred;
		}
		return this.ajax("POST","/games/" + game.id + "/moves",{ data : move.toJSON()}).then(function(result) {
			game.fromJSON(result.data);
			move.fromJSON(result.data);
		});
	}
	,__class__: fovea.ganomede.GanomedeTurnGameClient
});
fovea.ganomede.GanomedeTurnGameEvent = $hx_exports.fovea.ganomede.GanomedeTurnGameEvent = function(g) {
	fovea.events.Event.call(this,g.type);
	this.turngame = g;
};
fovea.ganomede.GanomedeTurnGameEvent.__name__ = true;
fovea.ganomede.GanomedeTurnGameEvent.__super__ = fovea.events.Event;
fovea.ganomede.GanomedeTurnGameEvent.prototype = $extend(fovea.events.Event.prototype,{
	__class__: fovea.ganomede.GanomedeTurnGameEvent
});
fovea.ganomede.GanomedeTurnGames = $hx_exports.fovea.ganomede.GanomedeTurnGames = function(client) {
	this.collection = new fovea.utils.Collection();
	var _g = this;
	fovea.ganomede.UserClient.call(this,client,$bind(this,this.turngameClientFactory),"turngame/v1");
	this.collection.modelFactory = function(json) {
		return new fovea.ganomede.models.GanomedeTurnGame(json);
	};
	this.addEventListener("reset",$bind(this,this.onReset));
	this.collection.addEventListener("change",$bind(this,this.dispatchEvent));
	if(client.notifications != null) client.notifications.listenTo("turngame/v1",function(e) {
		var event = e;
		if(event.notification.type == "move") {
			_g.collection.merge(event.notification.data.game);
			_g.refresh(new fovea.ganomede.models.GanomedeTurnGame({ id : event.notification.data.game.id}));
		}
	});
};
fovea.ganomede.GanomedeTurnGames.__name__ = true;
fovea.ganomede.GanomedeTurnGames.__super__ = fovea.ganomede.UserClient;
fovea.ganomede.GanomedeTurnGames.prototype = $extend(fovea.ganomede.UserClient.prototype,{
	toJSON: function() {
		return this.collection.toJSON();
	}
	,turngameClientFactory: function(url,token) {
		return new fovea.ganomede.GanomedeTurnGameClient(url,token);
	}
	,onReset: function(event) {
		this.collection.flushall();
	}
	,get: function(id) {
		return js.Boot.__cast(this.collection.get(id) , fovea.ganomede.models.GanomedeTurnGame);
	}
	,add: function(turngame) {
		var _g = this;
		if(!this.client.users.me.isAuthenticated()) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("cant create turngame: not authenticated",{ fileName : "GanomedeTurnGames.hx", lineNumber : 64, className : "fovea.ganomede.GanomedeTurnGames", methodName : "add"});
			return this.error("CLIENT");
		}
		return this.executeAuth(function() {
			var turngamesClient = _g.authClient;
			return turngamesClient.addGame(turngame);
		}).then(function(outcome) {
			_g.collection.merge(turngame.toJSON());
		});
	}
	,refresh: function(turngame) {
		var _g = this;
		if(!this.client.users.me.isAuthenticated()) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("cant load turngame: not authenticated",{ fileName : "GanomedeTurnGames.hx", lineNumber : 78, className : "fovea.ganomede.GanomedeTurnGames", methodName : "refresh"});
			return this.error("CLIENT");
		}
		return this.executeAuth(function() {
			var turngamesClient = _g.authClient;
			return turngamesClient.getGame(turngame);
		}).then(function(outcome) {
			_g.collection.merge(turngame.toJSON());
		});
	}
	,addMove: function(turngame,move) {
		var _g = this;
		if(!this.client.users.me.isAuthenticated()) {
			if(fovea.net.Ajax.verbose) haxe.Log.trace("cant add move to turngame: not authenticated",{ fileName : "GanomedeTurnGames.hx", lineNumber : 92, className : "fovea.ganomede.GanomedeTurnGames", methodName : "addMove"});
			return this.error("CLIENT");
		}
		return this.executeAuth(function() {
			var turngamesClient = _g.authClient;
			return turngamesClient.addMove(turngame,move);
		}).then(function(outcome) {
			_g.collection.merge(turngame.toJSON());
		});
	}
	,refreshArray: function(array) {
		var _g = this;
		return fovea.async.Parallel.runWithArgs(array,function(id) {
			var deferred = new fovea.async.Deferred();
			_g.refresh(new fovea.ganomede.models.GanomedeTurnGame({ id : id})).then($bind(deferred,deferred.resolve)).error(function(err) {
				if(fovea.net.Ajax.verbose) haxe.Log.trace("failed to refresh turngame(" + id + "): " + Std.string(err),{ fileName : "GanomedeTurnGames.hx", lineNumber : 111, className : "fovea.ganomede.GanomedeTurnGames", methodName : "refreshArray"});
				deferred.resolve(null);
			});
			return deferred;
		});
	}
	,__class__: fovea.ganomede.GanomedeTurnGames
});
fovea.ganomede.GanomedeTurnGamesComposite = $hx_exports.fovea.ganomede.GanomedeTurnGamesComposite = function(client,pool) {
	this.listenedToMap = new haxe.ds.StringMap();
	this.idMap = new haxe.ds.StringMap();
	this.pool = pool;
	this.client = client;
};
fovea.ganomede.GanomedeTurnGamesComposite.__name__ = true;
fovea.ganomede.GanomedeTurnGamesComposite.__super__ = fovea.events.Events;
fovea.ganomede.GanomedeTurnGamesComposite.prototype = $extend(fovea.events.Events.prototype,{
	add: function(turngame) {
		var deferred = new fovea.async.Deferred();
		this.prepareClient(turngame).then((function($this) {
			var $r;
			var clientPrepared = function(result) {
				var client = result.client;
				if(client == null || client.turngames == null) {
					deferred.reject(new fovea.ganomede.ApiError("CLIENT",400));
					return;
				}
				client.turngames.add(turngame).then($bind(deferred,deferred.resolve)).error($bind(deferred,deferred.reject));
			};
			$r = clientPrepared;
			return $r;
		}(this))).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,listenToClient: function(id,client) {
		var _g = this;
		if(this.listenedToMap.exists("" + id)) return;
		this.listenedToMap.set("" + id,true);
		if(client.notifications != null) client.notifications.listenTo("turngame/v1",(function($this) {
			var $r;
			var turngameNotification = function(e) {
				var event = e;
				if(event.notification.type == "move") {
					var gameJson = event.notification.data.game;
					var game = _g.get(gameJson.id);
					if(game != null) {
						game.fromJSON(gameJson);
						_g.dispatchEvent(new fovea.ganomede.GanomedeTurnGameEvent(game));
					}
				}
			};
			$r = turngameNotification;
			return $r;
		}(this)));
	}
	,prepareClient: function(game) {
		var _g = this;
		var deferred = new fovea.async.Deferred();
		this.pool.initializeClient(game.url,{ turngames : { enabled : true}, users : { enabled : true}, notifications : { enabled : true}}).then((function($this) {
			var $r;
			var clientInitialized = function(result) {
				var client = result.client;
				if(client == null) {
					deferred.reject(new fovea.ganomede.ApiError("CLIENT",400));
					return;
				}
				_g.listenToClient(result.id,client);
				if(!client.users.me.isAuthenticated()) client.users.login(new fovea.ganomede.GanomedeUser({ username : _g.client.users.me.username, password : _g.client.users.me.password})).then((function($this) {
					var $r;
					var userLoggedIn = function(outcome) {
						_g.idMap.set(game.id,result.id);
						deferred.resolve(result);
					};
					$r = userLoggedIn;
					return $r;
				}(this))).error($bind(deferred,deferred.reject)); else deferred.resolve(result);
			};
			$r = clientInitialized;
			return $r;
		}(this))).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,get: function(id) {
		if(this.idMap.exists(id)) {
			var client = this.pool.getClient(this.idMap.get(id));
			return client.turngames.get(id);
		} else return null;
	}
	,refresh: function(turngame) {
		var _g = this;
		if(this.idMap.exists(turngame.id)) {
			var client = this.pool.getClient(this.idMap.get(turngame.id));
			return client.turngames.refresh(turngame);
		}
		var deferred = new fovea.async.Deferred();
		if(turngame.url != null) this.prepareClient(turngame).then((function($this) {
			var $r;
			var clientPrepared = function(result) {
				var client1 = result.client;
				client1.turngames.refresh(turngame).then((function($this) {
					var $r;
					var turngamesRefreshed = function(outcome) {
						_g.idMap.set(turngame.id,result.id);
						deferred.resolve(result);
					};
					$r = turngamesRefreshed;
					return $r;
				}(this))).error($bind(deferred,deferred.reject));
			};
			$r = clientPrepared;
			return $r;
		}(this))).error($bind(deferred,deferred.reject)); else deferred.reject(new fovea.ganomede.ApiError("HTTP",400));
		return deferred;
	}
	,addMove: function(turngame,turnmove) {
		var deferred = new fovea.async.Deferred();
		this.prepareClient(turngame).then((function($this) {
			var $r;
			var clientPrepared = function(result) {
				var client = result.client;
				client.turngames.addMove(turngame,turnmove).then($bind(deferred,deferred.resolve)).error($bind(deferred,deferred.reject));
			};
			$r = clientPrepared;
			return $r;
		}(this))).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,refreshArray: function(array,on404) {
		var _g = this;
		return fovea.async.Parallel.runWithArgs(array,function(turngame) {
			var deferred = new fovea.async.Deferred();
			_g.refresh(turngame).always(function() {
				deferred.resolve(null);
			}).error(function(error) {
				if(on404 != null) on404(turngame,error);
			});
			return deferred;
		});
	}
	,__class__: fovea.ganomede.GanomedeTurnGamesComposite
});
fovea.ganomede.GanomedeUser = $hx_exports.fovea.ganomede.GanomedeUser = function(obj) {
	this.token = null;
	if(obj != null) {
		this.username = obj.username;
		this.givenName = obj.givenName;
		this.surname = obj.surname;
		this.email = obj.email;
		this.password = obj.password;
		this.set_token(obj.token);
		this.facebookId = obj.facebookId;
		this.facebookToken = obj.facebookToken;
		this.appleId = obj.appleId;
		this.appleIdentityToken = obj.appleIdentityToken;
		this.appleAuthorizationCode = obj.appleAuthorizationCode;
		this.metadata = obj.metadata;
	}
};
fovea.ganomede.GanomedeUser.__name__ = true;
fovea.ganomede.GanomedeUser.prototype = {
	set_token: function(value) {
		this.token = value;
		if(this.token == "") this.token = null;
		return this.token;
	}
	,isAuthenticated: function() {
		return !(this.token == null || this.token == "");
	}
	,fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.username) this.username = obj.username;
		if(obj.givenName) this.givenName = obj.givenName;
		if(obj.surname) this.surname = obj.surname;
		if(obj.email) this.email = obj.email;
		if(obj.password) this.password = obj.password;
		if(obj.token) this.set_token(obj.token);
		if(obj.appleId) this.appleId = obj.appleId;
		if(obj.appleIdentityToken) this.appleIdentityToken = obj.appleIdentityToken;
		if(obj.appleAuthorizationCode) this.appleAuthorizationCode = obj.appleAuthorizationCode;
		if(obj.facebookId) this.facebookId = obj.facebookId;
		if(obj.facebookToken) this.facebookToken = obj.facebookToken;
		if(obj.metadata) this.metadata = obj.metadata;
	}
	,toJSON: function() {
		return { username : this.username, givenName : this.givenName, surname : this.surname, email : this.email, password : this.password, token : this.token, appleId : this.appleId, appleIdentityToken : this.appleIdentityToken, appleAuthorizationCode : this.appleAuthorizationCode, facebookId : this.facebookId, facebookToken : this.facebookToken, metadata : this.metadata};
	}
	,__class__: fovea.ganomede.GanomedeUser
};
fovea.ganomede.GanomedeUsers = $hx_exports.fovea.ganomede.GanomedeUsers = function(client) {
	this.friends = new Array();
	this.loginStatus = new fovea.utils.ReadyStatus();
	this.me = new fovea.ganomede.GanomedeUser();
	this.client = null;
	this.initialized = false;
	fovea.ganomede.ApiClient.call(this,client.url + "/" + "users/v1");
	this.client = client;
};
fovea.ganomede.GanomedeUsers.__name__ = true;
fovea.ganomede.GanomedeUsers.__super__ = fovea.ganomede.ApiClient;
fovea.ganomede.GanomedeUsers.prototype = $extend(fovea.ganomede.ApiClient.prototype,{
	initialize: function() {
		var _g = this;
		var deferred = new fovea.async.Deferred();
		deferred.resolve();
		return deferred.then((function($this) {
			var $r;
			var initializedFn = function(obj) {
				_g.initialized = true;
				if(_g.me.isAuthenticated()) _g.dispatchLoginEvent(null);
			};
			$r = initializedFn;
			return $r;
		}(this)));
	}
	,dispatchLoginEvent: function(result) {
		this.dispatchEvent(new fovea.events.Event("ganomede.login"));
		this.loginStatus.setReady();
	}
	,signUp: function(user) {
		this.me = user;
		return this.ajax("POST","/accounts",{ data : user.toJSON(), parse : $bind(this,this.parseMe)}).then($bind(this,this.dispatchLoginEvent));
	}
	,passwordResetEmail: function() {
		return this.ajax("POST","/auth/" + this.me.token + "/passwordResetEmail");
	}
	,forgotPassword: function(email) {
		return this.ajax("POST","/passwordResetEmail",{ data : { email : email}});
	}
	,login: function(user) {
		this.me = user;
		return this.ajax("POST","/login",{ data : { username : user.username, password : user.password, appleId : user.appleId, appleIdentityToken : user.appleIdentityToken, appleAuthorizationCode : user.appleAuthorizationCode, facebookId : user.facebookId, facebookToken : user.facebookToken}, parse : $bind(this,this.parseMe)}).then($bind(this,this.dispatchLoginEvent));
	}
	,logout: function() {
		this.me = new fovea.ganomede.GanomedeUser();
		this.dispatchEvent(new fovea.events.Event("ganomede.logout"));
	}
	,fetch: function(user) {
		var _g = this;
		var deferred = new fovea.async.Deferred();
		if(user.username == this.me.username || user.email == this.me.username || user.username == this.me.email) this.ajax("GET","/auth/" + this.me.token + "/me",{ parse : $bind(this,this.parseMe)}).then((function($this) {
			var $r;
			var fetched = function(outcome) {
				deferred.resolve(user);
				_g.loginStatus.setReady();
			};
			$r = fetched;
			return $r;
		}(this))).error($bind(deferred,deferred.reject)); else deferred.reject(new fovea.ganomede.ApiError("IO"));
		return deferred;
	}
	,loadUserMetadata: function(username,key) {
		var deferred = new fovea.async.Deferred();
		var endpoint = "/" + username + "/metadata/" + key;
		var obj = this.cached("GET",endpoint);
		if(obj) deferred.resolve(obj.data); else this.cachedAjax("GET",endpoint).then((function($this) {
			var $r;
			var metadataLoaded = function(obj1) {
				deferred.resolve(obj1.data);
			};
			$r = metadataLoaded;
			return $r;
		}(this))).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,loadMetadata: function(key) {
		var _g = this;
		if(this.me != null && key == "email" && this.me.email != null) return new fovea.async.Deferred().resolve({ value : this.me.email}); else if(this.me != null && this.me.metadata != null && Object.prototype.hasOwnProperty.call(this.me.metadata,key)) return new fovea.async.Deferred().resolve({ value : Reflect.field(this.me.metadata,key)}); else if(this.me.token == null) return new fovea.async.Deferred().resolve({ value : null});
		return this.loadUserMetadata("auth/" + this.me.token,key).then(function(outcome) {
			if(_g.me == null) return;
			if(_g.me.metadata == null) _g.me.metadata = { };
			if(key == "email") _g.me.email = outcome.value; else _g.me.metadata[key] = outcome.value;
		});
	}
	,loadMetadatas: function(keys) {
		var _g = this;
		var ret = { };
		var load = function(key) {
			return _g.loadMetadata(key).then(function(outcome) {
				ret[key] = outcome.value;
			});
		};
		var deferred = new fovea.async.Deferred();
		fovea.async.Parallel.runWithArgs(keys,load).then(function(outcome1) {
			deferred.resolve(ret);
		}).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,loadUsersMetadata: function(usernames,key) {
		var _g = this;
		var ret = [];
		var load = function(username) {
			return _g.loadUserMetadata(username,key).then(function(outcome) {
				ret.push({ username : username, key : key, value : outcome.value});
			});
		};
		var deferred = new fovea.async.Deferred();
		fovea.async.Parallel.runWithArgs(usernames,load).then(function(outcome1) {
			deferred.resolve({ metadatas : ret});
		}).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,setUserCache: function(username,key,data) {
		var endpoint = "/" + username + "/metadata/" + key;
		this.setCache("GET",endpoint,{ status : 200, data : data});
	}
	,saveMetadata: function(key,value) {
		if(this.me.token == null || this.me.token == "undefined") return new fovea.async.Deferred().reject(new openfl.errors.Error("Not authenticated"));
		var endpoint = "/auth/" + this.me.token + "/metadata/" + key;
		var data = { value : value};
		this.setUserCache("auth/" + this.me.token,key,data);
		this.setUserCache(this.me.username,key,data);
		return this.ajax("POST",endpoint,{ data : data});
	}
	,refreshFriends: function() {
		var _g = this;
		var endpoint = "/auth/" + this.me.token + "/friends";
		return this.ajax("GET",endpoint).then((function($this) {
			var $r;
			var friendsRefreshed = function(outcome) {
				_g.friends = outcome.data;
			};
			$r = friendsRefreshed;
			return $r;
		}(this)));
	}
	,addFriend: function(userId) {
		var _g = this;
		var endpoint = "/auth/" + this.me.token + "/friends";
		if(HxOverrides.indexOf(this.friends,userId,0) >= 0) return new fovea.async.Deferred().resolve({ });
		return this.ajax("POST",endpoint,{ data : [userId]}).then(function(outcome) {
			_g.friends.push(userId);
		});
	}
	,removeFriend: function(username) {
		var _g = this;
		var endpoint = "/auth/" + this.me.token + "/friends/" + this.encodeURIComponent(username);
		return this.ajax("DELETE",endpoint).then(function(outcome) {
			HxOverrides.remove(_g.friends,username);
		});
	}
	,reportUser: function(username) {
		var endpoint = "/auth/" + this.me.token + "/reported-user";
		return this.ajax("POST",endpoint,{ data : { username : username}});
	}
	,encodeURIComponent: function(s) {
		return StringTools.replace(s,"/","%2F");
	}
	,unblockUser: function(username) {
		var endpoint = "/auth/" + this.me.token + "/blocked-users/" + this.encodeURIComponent(username);
		return this.ajax("DELETE",endpoint);
	}
	,blockUser: function(username) {
		var endpoint = "/auth/" + this.me.token + "/blocked-users";
		return this.ajax("POST",endpoint,{ data : { username : username}});
	}
	,parseMe: function(obj) {
		var oldToken = this.me.token;
		var oldUsername = this.me.username;
		this.me.fromJSON(obj);
		if(this.me.token != oldToken || this.me.username != oldUsername) this.dispatchEvent(new fovea.events.Event("ganomede.auth"));
		return this.me;
	}
	,__class__: fovea.ganomede.GanomedeUsers
});
fovea.ganomede.GanomedeVirtualCurrency = $hx_exports.fovea.ganomede.GanomedeVirtualCurrency = function(client) {
	this.purchases = new fovea.utils.Collection();
	this.balances = new fovea.utils.Collection();
	this.products = new fovea.utils.Collection();
	this.knownCurrencies = [];
	fovea.ganomede.UserClient.call(this,client,$bind(this,this.virtualcurrencyClientFactory),"virtualcurrency/v1");
	this.initProducts();
	this.initBalances();
	this.initPurchases();
	this.addEventListener("reset",$bind(this,this.onReset));
};
fovea.ganomede.GanomedeVirtualCurrency.__name__ = true;
fovea.ganomede.GanomedeVirtualCurrency.__super__ = fovea.ganomede.UserClient;
fovea.ganomede.GanomedeVirtualCurrency.prototype = $extend(fovea.ganomede.UserClient.prototype,{
	isKnown: function(currency) {
		var _g1 = 0;
		var _g = this.knownCurrencies.length;
		while(_g1 < _g) {
			var i = _g1++;
			if(this.knownCurrencies[i] == currency) return true;
		}
		return false;
	}
	,rememberCurrency: function(currency) {
		if(!this.isKnown(currency)) this.knownCurrencies.push(currency);
	}
	,initProducts: function() {
		var productFactory = function(json) {
			return new fovea.ganomede.models.GanomedeVProduct(json);
		};
		this.products.modelFactory = productFactory;
		this.products.addEventListener("change",$bind(this,this.dispatchEvent));
	}
	,refreshProductsArray: function() {
		var _g = this;
		return this.refreshCollection(this.products,(function($this) {
			var $r;
			var arrayRefreshed = function() {
				return (js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeVirtualCurrencyClient)).listProducts();
			};
			$r = arrayRefreshed;
			return $r;
		}(this)));
	}
	,initBalances: function() {
		var _g = this;
		var balanceFactor = function(json) {
			return new fovea.ganomede.models.GanomedeVMoney(json);
		};
		this.balances.modelFactory = balanceFactor;
		this.balances.addEventListener("change",$bind(this,this.dispatchEvent));
		if(this.client.notifications != null) this.client.notifications.listenTo("virtualcurrency/v1",(function($this) {
			var $r;
			var virtualcurrencyNotification = function(event) {
				_g.refreshBalancesArray();
			};
			$r = virtualcurrencyNotification;
			return $r;
		}(this)));
	}
	,refreshBalances: function(currencies,deferred) {
		var _g = this;
		var _g1 = 0;
		var _g2 = currencies.length;
		while(_g1 < _g2) {
			var i = _g1++;
			this.rememberCurrency(currencies[i]);
		}
		if(deferred == null) deferred = new fovea.async.Deferred();
		if(!this.isAuthOK()) {
			haxe.Timer.delay(function() {
				_g.refreshBalances(currencies,deferred);
			},1000);
			return deferred;
		}
		this.executeAuth(function() {
			return (js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeVirtualCurrencyClient)).getCount(currencies);
		}).then((function($this) {
			var $r;
			var getCountResult = function(outcome) {
				if(outcome.data) {
					var data = outcome.data;
					var _g11 = 0;
					var _g3 = data.length;
					while(_g11 < _g3) {
						var i1 = _g11++;
						data[i1].id = data[i1].currency;
					}
					_g.balances.merge(outcome);
				}
				deferred.resolve(outcome);
			};
			$r = getCountResult;
			return $r;
		}(this))).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,refreshBalancesArray: function() {
		this.refreshBalances(this.knownCurrencies);
	}
	,initPurchases: function() {
		var purchaseFactor = function(json) {
			return new fovea.ganomede.models.GanomedeVTransaction(json);
		};
		this.purchases.modelFactory = purchaseFactor;
		this.purchases.addEventListener("change",$bind(this,this.dispatchEvent));
	}
	,refreshPurchasesArray: function(currencies) {
		var _g = this;
		if(currencies != null) {
			var _g1 = 0;
			var _g2 = currencies.length;
			while(_g1 < _g2) {
				var i = _g1++;
				this.rememberCurrency(currencies[i]);
			}
		} else currencies = this.knownCurrencies;
		return this.refreshCollection(this.purchases,function() {
			return (js.Boot.__cast(_g.authClient , fovea.ganomede.GanomedeVirtualCurrencyClient)).getTransactions({ reasons : "purchase", currencies : currencies, limit : 999999});
		});
	}
	,virtualcurrencyClientFactory: function(url,token) {
		return new fovea.ganomede.GanomedeVirtualCurrencyClient(url,token);
	}
	,onReset: function(event) {
		this.products.flushall();
		this.balances.flushall();
		this.purchases.flushall();
		this.refreshProductsArray();
		this.refreshPurchasesArray();
		this.refreshBalancesArray();
	}
	,finalizePurchase: function(deferred) {
		var _g = this;
		var finalize = null;
		finalize = function() {
			_g.refreshPurchasesArray().then($bind(deferred,deferred.resolve)).error(function(err) {
				haxe.Timer.delay(finalize,1000);
			});
		};
		finalize();
	}
	,purchase: function(pid,cost) {
		var _g = this;
		var deferred = new fovea.async.Deferred();
		(js.Boot.__cast(this.authClient , fovea.ganomede.GanomedeVirtualCurrencyClient)).addPurchase(pid,cost).then((function($this) {
			var $r;
			var getTransactionsResult = function(outcome) {
				_g.finalizePurchase(deferred);
				_g.refreshBalancesArray();
			};
			$r = getTransactionsResult;
			return $r;
		}(this))).error($bind(deferred,deferred.reject));
		return deferred;
	}
	,purchasePack: function(packPurchase) {
		return (js.Boot.__cast(this.authClient , fovea.ganomede.GanomedeVirtualCurrencyClient)).addPackPurchase(packPurchase);
	}
	,__class__: fovea.ganomede.GanomedeVirtualCurrency
});
fovea.ganomede.GanomedeVirtualCurrencyClient = $hx_exports.fovea.ganomede.GanomedeVirtualCurrencyClient = function(baseUrl,token) {
	fovea.ganomede.AuthenticatedClient.call(this,baseUrl,"virtualcurrency/v1",token);
};
fovea.ganomede.GanomedeVirtualCurrencyClient.__name__ = true;
fovea.ganomede.GanomedeVirtualCurrencyClient.__super__ = fovea.ganomede.AuthenticatedClient;
fovea.ganomede.GanomedeVirtualCurrencyClient.prototype = $extend(fovea.ganomede.AuthenticatedClient.prototype,{
	listProducts: function() {
		return this.cachedAjax("GET","/products?limit=999999");
	}
	,getCount: function(currencyCodes) {
		return this.ajax("GET","/coins/" + currencyCodes.join(",") + "/count",{ cache : false});
	}
	,pushVar: function(array,options,variable) {
		if(options != null) {
			var value = Reflect.field(options,variable);
			if(value != null) array.push(variable + "=" + Std.string(value));
		}
	}
	,pushArray: function(array,options,variable) {
		if(options != null) {
			var value = Reflect.field(options,variable);
			if(value != null) array.push(variable + "=" + value.join(","));
		}
	}
	,makePath: function(p,vars) {
		if(vars.length > 0) return p + "?" + vars.join("&"); else return p;
	}
	,getTransactions: function(options) {
		var vars = [];
		this.pushArray(vars,options,"currencies");
		this.pushVar(vars,options,"reasons");
		this.pushVar(vars,options,"limit");
		return this.ajax("GET",this.makePath("/transactions",vars));
	}
	,addPurchase: function(productId,cost) {
		var data = { itemId : productId, cost : { }};
		data.cost[cost.id] = cost.count;
		return this.ajax("POST","/purchases",{ data : data});
	}
	,addPackPurchase: function(packPurchase) {
		return this.ajax("POST","/packs/" + packPurchase.packId + "/purchases",{ data : packPurchase.toJSON()});
	}
	,__class__: fovea.ganomede.GanomedeVirtualCurrencyClient
});
fovea.utils = {};
fovea.utils.Model = $hx_exports.fovea.utils.Model = function(json) {
	if(json) this.fromJSON(json);
};
fovea.utils.Model.__name__ = true;
fovea.utils.Model.prototype = {
	fromJSON: function(json) {
		this.id = json.id;
	}
	,toJSON: function() {
		return { id : this.id};
	}
	,equals: function(obj) {
		return JSON.stringify(this.toJSON()) == JSON.stringify(obj);
	}
	,__class__: fovea.utils.Model
};
fovea.ganomede.models = {};
fovea.ganomede.models.GanomedeInvitation = $hx_exports.fovea.ganomede.models.GanomedeInvitation = function(obj) {
	this.index = 0;
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedeInvitation.__name__ = true;
fovea.ganomede.models.GanomedeInvitation.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedeInvitation.prototype = $extend(fovea.utils.Model.prototype,{
	fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.id) this.id = obj.id;
		if(obj.gameId) this.gameId = obj.gameId;
		if(obj.type) this.type = obj.type;
		if(obj.to) this.to = obj.to;
		if(obj.from) this.from = obj.from;
		if(obj.index) this.index = obj.index;
	}
	,toJSON: function() {
		return { id : this.id, gameId : this.gameId, type : this.type, to : this.to, from : this.from, index : this.index};
	}
	,__class__: fovea.ganomede.models.GanomedeInvitation
});
fovea.ganomede.helpers = {};
fovea.ganomede.helpers.GanomedeTurnGameInvitation = $hx_exports.fovea.ganomede.helpers.GanomedeTurnGameInvitation = function(client,obj) {
	this.client = client;
	fovea.ganomede.models.GanomedeInvitation.call(this,obj);
};
fovea.ganomede.helpers.GanomedeTurnGameInvitation.__name__ = true;
fovea.ganomede.helpers.GanomedeTurnGameInvitation.__super__ = fovea.ganomede.models.GanomedeInvitation;
fovea.ganomede.helpers.GanomedeTurnGameInvitation.prototype = $extend(fovea.ganomede.models.GanomedeInvitation.prototype,{
	alreadyHasGameWith: function(friend) {
		var array = this.client.games.collection.asArray();
		var _g1 = 0;
		var _g = array.length;
		while(_g1 < _g) {
			var i = _g1++;
			var g = array[i];
			if(g.status != "gameover") {
				var _g3 = 0;
				var _g2 = g.players.length;
				while(_g3 < _g2) {
					var j = _g3++;
					if(g.players[j] == friend) return true;
				}
			}
		}
		return false;
	}
	,alreadyHasInvitationTo: function(friend) {
		var array = this.client.invitations.collection.asArray();
		var _g1 = 0;
		var _g = array.length;
		while(_g1 < _g) {
			var i = _g1++;
			var g = array[i];
			if(g.to == friend) return true;
		}
		return false;
	}
	,canInvite: function(friend) {
		return !this.alreadyHasGameWith(friend) && !this.alreadyHasInvitationTo(friend);
	}
	,send: function(game,gameConfig,force) {
		if(force == null) force = false;
		var _g = this;
		var friend = game.players[game.players.length - 1];
		return fovea.async.Waterfall.run([function() {
			var deferred = new fovea.async.Deferred();
			if(!force && _g.alreadyHasGameWith(friend)) deferred.reject(new fovea.ganomede.ApiError("HTTP",400,{ code : "DuplicateGame", message : "A game with this player already exists"})); else deferred.resolve(null);
			return deferred;
		},function() {
			var deferred1 = new fovea.async.Deferred();
			if(!force && _g.alreadyHasInvitationTo(friend)) deferred1.reject(new fovea.ganomede.ApiError("HTTP",400,{ code : "DuplicateInvitation", message : "An invitation with this player already exists"})); else deferred1.resolve(null);
			return deferred1;
		},function() {
			return _g.client.games.add(game);
		},function() {
			var data = game.toJSON();
			data.gameConfig = gameConfig;
			var turngame = new fovea.ganomede.models.GanomedeTurnGame(data);
			return _g.client.turngames.add(turngame);
		},function() {
			_g.fromJSON({ type : game.type, to : friend, gameId : game.id});
			return _g.client.invitations.add(_g);
		}]);
	}
	,accept: function() {
		var _g = this;
		return fovea.async.Waterfall.run([function() {
			return _g.client.invitations.accept(_g);
		},function() {
			return _g.client.games.join(new fovea.ganomede.models.GanomedeGame({ id : _g.gameId}));
		}]);
	}
	,__class__: fovea.ganomede.helpers.GanomedeTurnGameInvitation
});
fovea.ganomede.helpers.GanomedeTurnGameMover = $hx_exports.fovea.ganomede.helpers.GanomedeTurnGameMover = function(client) {
	this.client = client;
};
fovea.ganomede.helpers.GanomedeTurnGameMover.__name__ = true;
fovea.ganomede.helpers.GanomedeTurnGameMover.prototype = {
	addMove: function(game,turngame,move) {
		var _g = this;
		return this.client.turngames.addMove(turngame,move).then(function(outcome) {
			if(turngame.status == "gameover") _g.client.games.gameover(game,turngame.gameData);
		});
	}
	,__class__: fovea.ganomede.helpers.GanomedeTurnGameMover
};
fovea.ganomede.models.GanomedeChallenge = $hx_exports.fovea.ganomede.models.GanomedeChallenge = function(obj) {
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedeChallenge.__name__ = true;
fovea.ganomede.models.GanomedeChallenge.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedeChallenge.prototype = $extend(fovea.utils.Model.prototype,{
	reset: function() {
		this.id = null;
		this.type = null;
		this.start = 0;
		this.end = 0;
		this.secondsToEnd = 0;
		this.gameData = null;
	}
	,fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.id) this.id = obj.id;
		if(obj.type) this.type = obj.type;
		if(obj.start) this.start = obj.start;
		if(obj.end) this.end = obj.end;
		if(obj.secondsToEnd) this.secondsToEnd = obj.secondsToEnd;
		if(obj.gameData) this.gameData = obj.gameData;
	}
	,toJSON: function() {
		return { id : this.id, type : this.type, gameData : this.gameData, start : this.start, end : this.end, secondsToEnd : this.secondsToEnd};
	}
	,__class__: fovea.ganomede.models.GanomedeChallenge
});
fovea.ganomede.models.GanomedeChallengeEntry = $hx_exports.fovea.ganomede.models.GanomedeChallengeEntry = function(obj) {
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedeChallengeEntry.__name__ = true;
fovea.ganomede.models.GanomedeChallengeEntry.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedeChallengeEntry.prototype = $extend(fovea.utils.Model.prototype,{
	fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.id) this.id = obj.id;
		if(obj.username) this.username = obj.username;
		if(obj.timestamp) this.timestamp = obj.timestamp; else if(obj.start) this.timestamp = obj.start;
		if(obj.score) this.score = obj.score;
		if(obj.time) this.time = obj.time;
		if(obj.bestTime) this.bestTime = obj.bestTime;
		if(obj.bestScore) this.bestScore = obj.bestScore;
		if(obj.ranking) this.ranking = obj.ranking;
		if(obj.challengeId) this.challengeId = obj.challengeId;
		if(obj.secondsToEnd) this.secondsToEnd = obj.secondsToEnd;
	}
	,toJSON: function() {
		return { id : this.id, username : this.username, timestamp : this.timestamp, score : this.score, time : this.time, bestTime : this.bestTime, bestScore : this.bestScore, ranking : this.ranking, secondsToEnd : this.secondsToEnd, challengeId : this.challengeId};
	}
	,__class__: fovea.ganomede.models.GanomedeChallengeEntry
});
fovea.ganomede.models.GanomedeChatMessage = $hx_exports.fovea.ganomede.models.GanomedeChatMessage = function(obj) {
	if(obj) this.fromJSON(obj);
};
fovea.ganomede.models.GanomedeChatMessage.__name__ = true;
fovea.ganomede.models.GanomedeChatMessage.prototype = {
	fromJSON: function(obj) {
		if(obj.timestamp) this.timestamp = obj.timestamp;
		if(obj.from) this.from = obj.from;
		if(obj.type) this.type = obj.type;
		if(obj.message) this.message = obj.message;
	}
	,toJSON: function() {
		return { timestamp : this.timestamp, from : this.from, type : this.type, message : this.message};
	}
	,__class__: fovea.ganomede.models.GanomedeChatMessage
};
fovea.ganomede.models.GanomedeChatRoom = $hx_exports.fovea.ganomede.models.GanomedeChatRoom = function(obj) {
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedeChatRoom.__name__ = true;
fovea.ganomede.models.GanomedeChatRoom.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedeChatRoom.prototype = $extend(fovea.utils.Model.prototype,{
	fromJSON: function(obj) {
		if(obj.id) this.id = obj.id;
		if(obj.type) this.type = obj.type;
		if(obj.users) this.users = obj.users;
		if(obj.messages) this.messages = obj.messages.map(function(o) {
			var m = new fovea.ganomede.models.GanomedeChatMessage();
			m.fromJSON(o);
			return m;
		});
	}
	,toJSON: function() {
		return { id : this.id, type : this.type, users : this.users, messages : this.messages.map(function(o) {
			return o.toJSON();
		})};
	}
	,__class__: fovea.ganomede.models.GanomedeChatRoom
});
fovea.ganomede.models.GanomedeGame = $hx_exports.fovea.ganomede.models.GanomedeGame = function(obj) {
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedeGame.__name__ = true;
fovea.ganomede.models.GanomedeGame.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedeGame.prototype = $extend(fovea.utils.Model.prototype,{
	fromJSON: function(obj) {
		if(obj.id) this.id = obj.id;
		if(obj.type) this.type = obj.type;
		if(obj.players) this.players = obj.players;
		if(obj.waiting) this.waiting = obj.waiting;
		if(obj.status) this.status = obj.status;
		if(obj.url) this.url = obj.url;
		if(obj.gameOverData) this.gameOverData = obj.gameOverData;
	}
	,toJSON: function() {
		return { id : this.id, type : this.type, players : this.players, waiting : this.waiting, status : this.status, url : this.url, gameOverData : this.gameOverData};
	}
	,__class__: fovea.ganomede.models.GanomedeGame
});
fovea.ganomede.models.GanomedeGameArchive = $hx_exports.fovea.ganomede.models.GanomedeGameArchive = function(obj) {
	if(obj != null) this.array = obj; else {
		var this1;
		this1 = new openfl.VectorData();
		var this2;
		this2 = new Array(0);
		this1.data = this2;
		this1.length = 0;
		this1.fixed = false;
		this.array = this1;
	}
};
fovea.ganomede.models.GanomedeGameArchive.__name__ = true;
fovea.ganomede.models.GanomedeGameArchive.fromJSON = function(obj) {
	var array;
	var length = obj.length;
	var this1;
	this1 = new openfl.VectorData();
	var this2;
	this2 = new Array(length);
	this1.data = this2;
	this1.length = length;
	this1.fixed = false;
	array = this1;
	var _g1 = 0;
	var _g = obj.length;
	while(_g1 < _g) {
		var i = _g1++;
		var value = new fovea.ganomede.models.GanomedeGameRank(obj[i]);
		if(!array.fixed) {
			if(i >= array.length) array.length = i + 1;
			if(array.data.length < array.length) {
				var data;
				var this3;
				this3 = new Array(array.data.length + 10);
				data = this3;
				haxe.ds._Vector.Vector_Impl_.blit(array.data,0,data,0,array.data.length);
				array.data = data;
			}
		}
		array.data[i] = value;
	}
	return new fovea.ganomede.models.GanomedeGameArchive(array);
};
fovea.ganomede.models.GanomedeGameArchive.prototype = {
	slice: function(startIndex,endIndex) {
		if(endIndex != null) return new fovea.ganomede.models.GanomedeGameArchive((function($this) {
			var $r;
			var this1 = $this.array;
			var pos = startIndex;
			var end = endIndex;
			if(pos < 0) pos += this1.length;
			if(end <= 0) end += this1.length;
			if(end > this1.length) end = this1.length;
			var length = end - pos;
			if(length <= 0 || length > this1.length) length = this1.length;
			var vectorData = new openfl.VectorData();
			vectorData.length = end - pos;
			vectorData.fixed = true;
			{
				var this2;
				this2 = new Array(length);
				vectorData.data = this2;
			}
			haxe.ds._Vector.Vector_Impl_.blit(this1.data,pos,vectorData.data,0,length);
			$r = vectorData;
			return $r;
		}(this))); else return new fovea.ganomede.models.GanomedeGameArchive((function($this) {
			var $r;
			var this3 = $this.array;
			var pos1 = startIndex;
			var end1 = 0;
			if(pos1 < 0) pos1 += this3.length;
			if(end1 <= 0) end1 += this3.length;
			if(end1 > this3.length) end1 = this3.length;
			var length1 = end1 - pos1;
			if(length1 <= 0 || length1 > this3.length) length1 = this3.length;
			var vectorData1 = new openfl.VectorData();
			vectorData1.length = end1 - pos1;
			vectorData1.fixed = true;
			{
				var this4;
				this4 = new Array(length1);
				vectorData1.data = this4;
			}
			haxe.ds._Vector.Vector_Impl_.blit(this3.data,pos1,vectorData1.data,0,length1);
			$r = vectorData1;
			return $r;
		}(this)));
	}
	,last: function(numEntries) {
		return this.slice(-numEntries);
	}
	,reverse: function() {
		var this1 = this.array;
		var data;
		var this2;
		this2 = new Array(this1.length);
		data = this2;
		var _g1 = 0;
		var _g = this1.length;
		while(_g1 < _g) {
			var i = _g1++;
			data[this1.length - 1 - i] = this1.data[i];
		}
		this1.data = data;
		return this;
	}
	,map: function(fn) {
		var _g = [];
		var _g2 = 0;
		var _g1 = this.array.length;
		while(_g2 < _g1) {
			var i = _g2++;
			_g.push(fn(this.array.data[i]));
		}
		return _g;
	}
	,forEach: function(fn) {
		var _g1 = 0;
		var _g = this.array.length;
		while(_g1 < _g) {
			var i = _g1++;
			fn(this.array.data[i]);
		}
	}
	,__class__: fovea.ganomede.models.GanomedeGameArchive
};
fovea.ganomede.models.GanomedeGameOutcome = $hx_exports.fovea.ganomede.models.GanomedeGameOutcome = function(obj) {
	this.newLevel = obj.newLevel;
	this.newRank = obj.newRank;
};
fovea.ganomede.models.GanomedeGameOutcome.__name__ = true;
fovea.ganomede.models.GanomedeGameOutcome.prototype = {
	toJSON: function() {
		return { newLevel : this.newLevel, newRank : this.newRank};
	}
	,__class__: fovea.ganomede.models.GanomedeGameOutcome
};
fovea.ganomede.models.GanomedeGameRank = $hx_exports.fovea.ganomede.models.GanomedeGameRank = function(obj) {
	this.game = new fovea.ganomede.models.GanomedeGameScores(obj.game);
	this.outcome = new fovea.ganomede.models.GanomedeGameOutcome(obj.outcome);
};
fovea.ganomede.models.GanomedeGameRank.__name__ = true;
fovea.ganomede.models.GanomedeGameRank.prototype = {
	toJSON: function() {
		return { game : this.game.toJSON(), outcome : this.outcome.toJSON()};
	}
	,id: function() {
		return this.game.id;
	}
	,date: function() {
		return this.game.date;
	}
	,numPlayers: function() {
		return this.game.players.length;
	}
	,player: function(index) {
		return this.game.players[index];
	}
	,newLevel: function() {
		return this.outcome.newLevel;
	}
	,newRank: function() {
		return this.outcome.newRank;
	}
	,__class__: fovea.ganomede.models.GanomedeGameRank
};
fovea.ganomede.models.GanomedeGameScores = $hx_exports.fovea.ganomede.models.GanomedeGameScores = function(obj) {
	this.id = obj.id;
	this.date = obj.date;
	this.players = obj.players.map(function(p) {
		return new fovea.ganomede.models.GanomedePlayerScore(p);
	});
};
fovea.ganomede.models.GanomedeGameScores.__name__ = true;
fovea.ganomede.models.GanomedeGameScores.prototype = {
	toJSON: function() {
		return { id : this.id, date : this.date, players : this.players.map(function(p) {
			return p.toJSON();
		})};
	}
	,__class__: fovea.ganomede.models.GanomedeGameScores
};
fovea.ganomede.models.GanomedePackPurchase = $hx_exports.fovea.ganomede.models.GanomedePackPurchase = function(obj) {
	this.fromJSON(obj);
};
fovea.ganomede.models.GanomedePackPurchase.__name__ = true;
fovea.ganomede.models.GanomedePackPurchase.prototype = {
	fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.packId) this.packId = obj.packId;
		if(obj.type) this.type = obj.type;
		if(obj.iosTransactionId) this.iosTransactionId = obj.iosTransactionId;
		if(obj.iosAppStoreReceipt) this.iosAppStoreReceipt = obj.iosAppStoreReceipt;
		if(obj.playTransactionId) this.playTransactionId = obj.playTransactionId;
		if(obj.playSignature) this.playSignature = obj.playSignature;
		if(obj.playSignedData) this.playSignedData = obj.playSignedData;
		if(obj.claimReason) this.claimReason = obj.claimReason;
		if(obj.claimData) this.claimData = obj.claimData;
	}
	,toJSON: function() {
		return { packId : this.packId, type : this.type, iosTransactionId : this.iosTransactionId, iosAppStoreReceipt : this.iosAppStoreReceipt, playTransactionId : this.playTransactionId, playSignature : this.playSignature, playSignedData : this.playSignedData, claimReason : this.claimReason, claimData : this.claimData};
	}
	,__class__: fovea.ganomede.models.GanomedePackPurchase
};
fovea.ganomede.models.GanomedePlayerScore = $hx_exports.fovea.ganomede.models.GanomedePlayerScore = function(obj) {
	this.username = obj.username;
	this.score = obj.score;
};
fovea.ganomede.models.GanomedePlayerScore.__name__ = true;
fovea.ganomede.models.GanomedePlayerScore.prototype = {
	toJSON: function() {
		return { username : this.username, score : this.score};
	}
	,__class__: fovea.ganomede.models.GanomedePlayerScore
};
fovea.ganomede.models.GanomedePushToken = $hx_exports.fovea.ganomede.models.GanomedePushToken = function(obj) {
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedePushToken.__name__ = true;
fovea.ganomede.models.GanomedePushToken.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedePushToken.prototype = $extend(fovea.utils.Model.prototype,{
	fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.type) this.type = obj.type;
		if(obj.app) this.app = obj.app;
		if(obj.value) this.value = obj.value;
	}
	,toJSON: function() {
		return { type : this.type, value : this.value, app : this.app};
	}
	,__class__: fovea.ganomede.models.GanomedePushToken
});
fovea.ganomede.models.GanomedeTurnGame = $hx_exports.fovea.ganomede.models.GanomedeTurnGame = function(obj) {
	this.listeners = new Array();
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedeTurnGame.__name__ = true;
fovea.ganomede.models.GanomedeTurnGame.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedeTurnGame.prototype = $extend(fovea.utils.Model.prototype,{
	fromGame: function(game) {
		this.fromJSON(game.toJSON());
		return this;
	}
	,fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.id && this.id != obj.id) {
			this.id = obj.id;
			this.dispatchUpdate();
		}
		if(obj.type && this.type != obj.type) {
			this.type = obj.type;
			this.dispatchUpdate();
		}
		if(obj.players && this.players != obj.players) {
			this.players = obj.players;
			this.dispatchUpdate();
		}
		if(obj.turn && this.turn != obj.turn) {
			this.turn = obj.turn;
			this.dispatchUpdate();
		}
		if(obj.status && this.status != obj.status) {
			this.status = obj.status;
			this.dispatchUpdate();
		}
		if(obj.gameData && this.gameData != obj.gameData) {
			this.gameData = obj.gameData;
			this.dispatchUpdate();
		}
		if(obj.gameConfig && this.gameConfig != obj.gameConfig) {
			this.gameConfig = obj.gameConfig;
			this.dispatchUpdate();
		}
		if(obj.url && this.url != obj.url) {
			this.url = obj.url;
			this.dispatchUpdate();
		}
	}
	,addListener: function(fn) {
		this.listeners.push(fn);
	}
	,removeListener: function(fn) {
		HxOverrides.remove(this.listeners,fn);
	}
	,dispatchUpdate: function() {
		var _g1 = 0;
		var _g = this.listeners.length;
		while(_g1 < _g) {
			var i = _g1++;
			this.listeners[i]();
		}
	}
	,toJSON: function() {
		return { id : this.id, type : this.type, players : this.players, turn : this.turn, status : this.status, gameData : this.gameData, gameConfig : this.gameConfig, url : this.url};
	}
	,__class__: fovea.ganomede.models.GanomedeTurnGame
});
fovea.ganomede.models.GanomedeTurnMove = $hx_exports.fovea.ganomede.models.GanomedeTurnMove = function(obj) {
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedeTurnMove.__name__ = true;
fovea.ganomede.models.GanomedeTurnMove.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedeTurnMove.prototype = $extend(fovea.utils.Model.prototype,{
	fromJSON: function(obj) {
		if(obj.id) this.id = obj.id;
		if(obj.moveData) this.moveData = obj.moveData;
		if(obj.moveResult) this.moveResult = obj.moveResult;
		if(obj.chatEvent) this.chatEvent = obj.chatEvent;
	}
	,toJSON: function() {
		return { id : this.id, moveData : this.moveData, moveResult : this.moveResult, chatEvent : this.chatEvent};
	}
	,__class__: fovea.ganomede.models.GanomedeTurnMove
});
fovea.ganomede.models.GanomedeVMoney = $hx_exports.fovea.ganomede.models.GanomedeVMoney = function(obj) {
	this.listeners = new Array();
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedeVMoney.__name__ = true;
fovea.ganomede.models.GanomedeVMoney.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedeVMoney.prototype = $extend(fovea.utils.Model.prototype,{
	fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.id && this.id != obj.id) {
			this.id = obj.id;
			this.dispatchUpdate();
		}
		if(!obj.count) obj.count = 0;
		if(this.count != obj.count) {
			this.count = obj.count;
			this.dispatchUpdate();
		}
	}
	,addListener: function(fn) {
		this.listeners.push(fn);
	}
	,removeListener: function(fn) {
		HxOverrides.remove(this.listeners,fn);
	}
	,dispatchUpdate: function() {
		var _g1 = 0;
		var _g = this.listeners.length;
		while(_g1 < _g) {
			var i = _g1++;
			this.listeners[i]();
		}
	}
	,toJSON: function() {
		return { id : this.id, count : this.count};
	}
	,__class__: fovea.ganomede.models.GanomedeVMoney
});
fovea.ganomede.models.GanomedeVProduct = $hx_exports.fovea.ganomede.models.GanomedeVProduct = function(obj) {
	this.listeners = new Array();
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedeVProduct.__name__ = true;
fovea.ganomede.models.GanomedeVProduct.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedeVProduct.prototype = $extend(fovea.utils.Model.prototype,{
	fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.id && this.id != obj.id) {
			this.id = obj.id;
			this.dispatchUpdate();
		}
		if(obj.costs && this.costs != obj.costs) {
			this.costs = obj.costs;
			this.dispatchUpdate();
		}
	}
	,addListener: function(fn) {
		this.listeners.push(fn);
	}
	,removeListener: function(fn) {
		HxOverrides.remove(this.listeners,fn);
	}
	,dispatchUpdate: function() {
		var _g1 = 0;
		var _g = this.listeners.length;
		while(_g1 < _g) {
			var i = _g1++;
			this.listeners[i]();
		}
	}
	,toJSON: function() {
		return { id : this.id, costs : this.costs};
	}
	,__class__: fovea.ganomede.models.GanomedeVProduct
});
fovea.ganomede.models.GanomedeVTransaction = $hx_exports.fovea.ganomede.models.GanomedeVTransaction = function(obj) {
	this.listeners = new Array();
	fovea.utils.Model.call(this,obj);
};
fovea.ganomede.models.GanomedeVTransaction.__name__ = true;
fovea.ganomede.models.GanomedeVTransaction.__super__ = fovea.utils.Model;
fovea.ganomede.models.GanomedeVTransaction.prototype = $extend(fovea.utils.Model.prototype,{
	fromJSON: function(obj) {
		if(obj == null) return;
		if(obj.id && this.id != obj.id) {
			this.id = obj.id;
			this.dispatchUpdate();
		}
		if(obj.type && this.type != obj.type) {
			this.type = obj.type;
			this.dispatchUpdate();
		}
		if(obj.currency && this.currency != obj.currency) {
			this.currency = obj.currency;
			this.dispatchUpdate();
		}
		if(obj.amount && this.amount != obj.amount) {
			this.amount = obj.amount;
			this.dispatchUpdate();
		}
		if(obj.timestamp && this.timestamp != obj.timestamp) {
			this.timestamp = obj.timestamp;
			this.dispatchUpdate();
		}
		if(obj.username && this.username != obj.username) {
			this.username = obj.username;
			this.dispatchUpdate();
		}
		if(obj.reason && this.reason != obj.reason) {
			this.reason = obj.reason;
			this.dispatchUpdate();
		}
		if(obj.data) {
			this.data = obj.data;
			this.dispatchUpdate();
		}
	}
	,addListener: function(fn) {
		this.listeners.push(fn);
	}
	,removeListener: function(fn) {
		HxOverrides.remove(this.listeners,fn);
	}
	,dispatchUpdate: function() {
		var _g1 = 0;
		var _g = this.listeners.length;
		while(_g1 < _g) {
			var i = _g1++;
			this.listeners[i]();
		}
	}
	,toJSON: function() {
		return { id : this.id, type : this.type, currency : this.currency, amount : this.amount, timestamp : this.timestamp, username : this.username, reason : this.reason, data : this.data};
	}
	,__class__: fovea.ganomede.models.GanomedeVTransaction
});
fovea.net.UrlFormatter = $hx_exports.fovea.net.UrlFormatter = function() {
};
fovea.net.UrlFormatter.__name__ = true;
fovea.net.UrlFormatter.format = function(url,params) {
	var array = [];
	var _g = 0;
	var _g1 = Reflect.fields(params);
	while(_g < _g1.length) {
		var k = _g1[_g];
		++_g;
		var v = Reflect.field(params,k);
		if(v != null) array.push(k + "=" + v);
	}
	if(array.length > 0) return url + "?" + array.join("&"); else return url;
};
fovea.net.UrlFormatter.prototype = {
	__class__: fovea.net.UrlFormatter
};
fovea.utils.Collection = $hx_exports.fovea.utils.Collection = function() {
	this.modelFactory = null;
	this.keepStrategy = null;
	this.map = new haxe.ds.StringMap();
	this.merger = new fovea.utils.StrategyChain([new fovea.utils._Collection.MergeArray(this),new fovea.utils._Collection.MergeExisting(this),new fovea.utils._Collection.MergeNonExisting(this)]);
};
fovea.utils.Collection.__name__ = true;
fovea.utils.Collection.__super__ = fovea.events.Events;
fovea.utils.Collection.prototype = $extend(fovea.events.Events.prototype,{
	asArray: function() {
		var ret = new Array();
		var keys = this.map.keys();
		while( keys.hasNext() ) {
			var key = keys.next();
			ret.push(this.map.get(key));
		}
		return ret;
	}
	,toJSON: function() {
		var ret = [];
		var keys = this.map.keys();
		while( keys.hasNext() ) {
			var key = keys.next();
			ret.push(this.map.get(key).toJSON());
		}
		return ret;
	}
	,forEach: function(fn) {
		var keys = this.map.keys();
		while( keys.hasNext() ) {
			var key = keys.next();
			fn(this.map.get(key));
		}
	}
	,get: function(key) {
		return this.map.get(key);
	}
	,del: function(key) {
		this.map.remove(key);
		this.dispatchEvent(new fovea.events.Event("del:" + key));
		this.dispatchEvent(new fovea.events.Event("del"));
	}
	,set: function(key,value) {
		this.map.set(key,value);
		this.dispatchEvent(new fovea.events.Event("set:" + key));
		this.dispatchEvent(new fovea.events.Event("set"));
	}
	,exists: function(key) {
		return this.map.exists(key);
	}
	,keep: function(keys) {
		var changed = false;
		var keepKeys = new haxe.ds.StringMap();
		var _g = 0;
		while(_g < keys.length) {
			var i = keys[_g];
			++_g;
			keepKeys.set(i,true);
		}
		var $it0 = this.map.keys();
		while( $it0.hasNext() ) {
			var key = $it0.next();
			if(!keepKeys.get(key)) {
				this.del(key);
				changed = true;
			}
		}
		return changed;
	}
	,flushall: function() {
		var oldMap = this.map;
		this.map = new haxe.ds.StringMap();
		var $it0 = oldMap.keys();
		while( $it0.hasNext() ) {
			var key = $it0.next();
			this.dispatchEvent(new fovea.events.Event("del:" + key));
		}
		this.dispatchEvent(new fovea.events.Event("del"));
	}
	,shouldKeep: function(item) {
		if(this.keepStrategy != null) return this.keepStrategy(item); else return true;
	}
	,newModel: function(json) {
		if(this.modelFactory != null) return this.modelFactory(json); else return null;
	}
	,merge: function(json) {
		if(this.merger.canExecute(json)) {
			var result = this.merger.execute(json);
			if(result != null && result.changed) {
				this.dispatchEvent(new fovea.events.Event("change"));
				return true;
			} else return false;
		} else return false;
	}
	,canMerge: function(json) {
		return this.merger.canExecute(json);
	}
	,__class__: fovea.utils.Collection
});
fovea.utils.Strategy = $hx_exports.fovea.utils.Strategy = function(canExecute,execute) {
	this.execute = null;
	this.canExecute = null;
	this.canExecute = canExecute;
	this.execute = execute;
};
fovea.utils.Strategy.__name__ = true;
fovea.utils.Strategy.prototype = {
	__class__: fovea.utils.Strategy
};
fovea.utils._Collection = {};
fovea.utils._Collection.MergeArray = function(collection) {
	fovea.utils.Strategy.call(this,function(json) {
		if(json == null || json.data == null) return false;
		if(!json.data.push) return false;
		var newArray;
		newArray = js.Boot.__cast(json.data , Array);
		if(newArray == null) return false;
		var _g1 = 0;
		var _g = newArray.length;
		while(_g1 < _g) {
			var i = _g1++;
			if(!collection.canMerge(newArray[i])) return false;
		}
		return true;
	},function(json1) {
		var newArray1;
		newArray1 = js.Boot.__cast(json1.data , Array);
		var keys = [];
		var _g2 = 0;
		while(_g2 < newArray1.length) {
			var model = newArray1[_g2];
			++_g2;
			keys.push(model.id);
		}
		var changed = collection.keep(keys);
		var i1;
		var _g11 = 0;
		var _g3 = newArray1.length;
		while(_g11 < _g3) {
			var i2 = _g11++;
			newArray1[i2].index = i2;
			if(collection.merge(newArray1[i2])) changed = true;
		}
		return { changed : changed};
	});
};
fovea.utils._Collection.MergeArray.__name__ = true;
fovea.utils._Collection.MergeArray.__super__ = fovea.utils.Strategy;
fovea.utils._Collection.MergeArray.prototype = $extend(fovea.utils.Strategy.prototype,{
	__class__: fovea.utils._Collection.MergeArray
});
fovea.utils._Collection.MergeExisting = function(collection) {
	fovea.utils.Strategy.call(this,function(json) {
		if(json == null || json.id == null) return false;
		return collection.exists(json.id);
	},function(json1) {
		var item = collection.get(json1.id);
		if(!item.equals(json1)) {
			item.fromJSON(json1);
			if(!collection.shouldKeep(item)) collection.del(json1.id);
			return { changed : true};
		} else return { changed : false};
	});
};
fovea.utils._Collection.MergeExisting.__name__ = true;
fovea.utils._Collection.MergeExisting.__super__ = fovea.utils.Strategy;
fovea.utils._Collection.MergeExisting.prototype = $extend(fovea.utils.Strategy.prototype,{
	__class__: fovea.utils._Collection.MergeExisting
});
fovea.utils._Collection.MergeNonExisting = function(collection) {
	fovea.utils.Strategy.call(this,function(json) {
		if(json == null || json.id == null) return false;
		return !collection.exists(json.id);
	},function(json1) {
		var item = collection.newModel(json1);
		if(collection.shouldKeep(item)) {
			collection.set(json1.id,item);
			return { changed : true};
		} else return { changed : false};
	});
};
fovea.utils._Collection.MergeNonExisting.__name__ = true;
fovea.utils._Collection.MergeNonExisting.__super__ = fovea.utils.Strategy;
fovea.utils._Collection.MergeNonExisting.prototype = $extend(fovea.utils.Strategy.prototype,{
	__class__: fovea.utils._Collection.MergeNonExisting
});
fovea.utils.ReadyStatus = $hx_exports.fovea.utils.ReadyStatus = function() {
	this.readyCallbacks = new Array();
	this.error = null;
	this.isReady = false;
};
fovea.utils.ReadyStatus.__name__ = true;
fovea.utils.ReadyStatus.prototype = {
	reset: function() {
		this.isReady = false;
		this.error = null;
		this.readyCallbacks = new Array();
	}
	,ready: function() {
		var deferred = new fovea.async.Deferred();
		if(this.isReady) deferred.resolve(null); else if(this.error != null) deferred.reject(this.error); else this.readyCallbacks.push(deferred);
		return deferred;
	}
	,setReady: function() {
		this.isReady = true;
		this.error = null;
		var a = this.readyCallbacks;
		this.readyCallbacks = new Array();
		var _g1 = 0;
		var _g = a.length;
		while(_g1 < _g) {
			var i = _g1++;
			a[i].resolve(null);
		}
	}
	,setError: function(err) {
		this.error = err;
		this.isReady = false;
		var a = this.readyCallbacks;
		this.readyCallbacks = new Array();
		var _g1 = 0;
		var _g = a.length;
		while(_g1 < _g) {
			var i = _g1++;
			a[i].reject(err);
		}
	}
	,__class__: fovea.utils.ReadyStatus
};
fovea.utils.StrategyChain = $hx_exports.fovea.utils.StrategyChain = function(strategies) {
	fovea.utils.Strategy.call(this,function(json) {
		var _g1 = 0;
		var _g = strategies.length;
		while(_g1 < _g) {
			var i = _g1++;
			if(strategies[i].canExecute(json)) return true;
		}
		return false;
	},function(json1) {
		var _g11 = 0;
		var _g2 = strategies.length;
		while(_g11 < _g2) {
			var i1 = _g11++;
			if(strategies[i1].canExecute(json1)) return strategies[i1].execute(json1);
		}
		return null;
	});
	this.strategies = strategies;
};
fovea.utils.StrategyChain.__name__ = true;
fovea.utils.StrategyChain.__super__ = fovea.utils.Strategy;
fovea.utils.StrategyChain.prototype = $extend(fovea.utils.Strategy.prototype,{
	executeAll: function(json) {
		var ret = [];
		var _g1 = 0;
		var _g = this.strategies.length;
		while(_g1 < _g) {
			var i = _g1++;
			if(this.strategies[i].canExecute(json)) ret.push(this.strategies[i].execute(json)); else ret.push(null);
		}
		return ret;
	}
	,__class__: fovea.utils.StrategyChain
});
var haxe = {};
haxe.StackItem = { __ename__ : true, __constructs__ : ["CFunction","Module","FilePos","Method","LocalFunction"] };
haxe.StackItem.CFunction = ["CFunction",0];
haxe.StackItem.CFunction.__enum__ = haxe.StackItem;
haxe.StackItem.Module = function(m) { var $x = ["Module",1,m]; $x.__enum__ = haxe.StackItem; return $x; };
haxe.StackItem.FilePos = function(s,file,line) { var $x = ["FilePos",2,s,file,line]; $x.__enum__ = haxe.StackItem; return $x; };
haxe.StackItem.Method = function(classname,method) { var $x = ["Method",3,classname,method]; $x.__enum__ = haxe.StackItem; return $x; };
haxe.StackItem.LocalFunction = function(v) { var $x = ["LocalFunction",4,v]; $x.__enum__ = haxe.StackItem; return $x; };
haxe.CallStack = function() { };
haxe.CallStack.__name__ = true;
haxe.CallStack.exceptionStack = function() {
	return [];
};
haxe.CallStack.toString = function(stack) {
	var b = new StringBuf();
	var _g = 0;
	while(_g < stack.length) {
		var s = stack[_g];
		++_g;
		b.b += "\nCalled from ";
		haxe.CallStack.itemToString(b,s);
	}
	return b.b;
};
haxe.CallStack.itemToString = function(b,s) {
	switch(s[1]) {
	case 0:
		b.b += "a C function";
		break;
	case 1:
		var m = s[2];
		b.b += "module ";
		if(m == null) b.b += "null"; else b.b += "" + m;
		break;
	case 2:
		var line = s[4];
		var file = s[3];
		var s1 = s[2];
		if(s1 != null) {
			haxe.CallStack.itemToString(b,s1);
			b.b += " (";
		}
		if(file == null) b.b += "null"; else b.b += "" + file;
		b.b += " line ";
		if(line == null) b.b += "null"; else b.b += "" + line;
		if(s1 != null) b.b += ")";
		break;
	case 3:
		var meth = s[3];
		var cname = s[2];
		if(cname == null) b.b += "null"; else b.b += "" + cname;
		b.b += ".";
		if(meth == null) b.b += "null"; else b.b += "" + meth;
		break;
	case 4:
		var n = s[2];
		b.b += "local function #";
		if(n == null) b.b += "null"; else b.b += "" + n;
		break;
	}
};
haxe.Log = function() { };
haxe.Log.__name__ = true;
haxe.Log.trace = function(v,infos) {
	js.Boot.__trace(v,infos);
};
haxe.Timer = function(time_ms) {
	var me = this;
	this.id = setInterval(function() {
		me.run();
	},time_ms);
};
haxe.Timer.__name__ = true;
haxe.Timer.delay = function(f,time_ms) {
	var t = new haxe.Timer(time_ms);
	t.run = function() {
		t.stop();
		f();
	};
	return t;
};
haxe.Timer.measure = function(f,pos) {
	var t0 = haxe.Timer.stamp();
	var r = f();
	haxe.Log.trace(haxe.Timer.stamp() - t0 + "s",pos);
	return r;
};
haxe.Timer.stamp = function() {
	return new Date().getTime() / 1000;
};
haxe.Timer.prototype = {
	stop: function() {
		if(this.id == null) return;
		clearInterval(this.id);
		this.id = null;
	}
	,run: function() {
	}
	,__class__: haxe.Timer
};
haxe.ds = {};
haxe.ds.StringMap = function() {
	this.h = { };
};
haxe.ds.StringMap.__name__ = true;
haxe.ds.StringMap.__interfaces__ = [IMap];
haxe.ds.StringMap.prototype = {
	set: function(key,value) {
		this.h["$" + key] = value;
	}
	,get: function(key) {
		return this.h["$" + key];
	}
	,exists: function(key) {
		return this.h.hasOwnProperty("$" + key);
	}
	,remove: function(key) {
		key = "$" + key;
		if(!this.h.hasOwnProperty(key)) return false;
		delete(this.h[key]);
		return true;
	}
	,keys: function() {
		var a = [];
		for( var key in this.h ) {
		if(this.h.hasOwnProperty(key)) a.push(key.substr(1));
		}
		return HxOverrides.iter(a);
	}
	,__class__: haxe.ds.StringMap
};
haxe.ds._Vector = {};
haxe.ds._Vector.Vector_Impl_ = function() { };
haxe.ds._Vector.Vector_Impl_.__name__ = true;
haxe.ds._Vector.Vector_Impl_.blit = function(src,srcPos,dest,destPos,len) {
	var _g = 0;
	while(_g < len) {
		var i = _g++;
		dest[destPos + i] = src[srcPos + i];
	}
};
haxe.ds._Vector.Vector_Impl_.toArray = function(this1) {
	var a = new Array();
	var len = this1.length;
	var _g = 0;
	while(_g < len) {
		var i = _g++;
		a[i] = this1[i];
	}
	return a;
};
var js = {};
js.Boot = function() { };
js.Boot.__name__ = true;
js.Boot.__unhtml = function(s) {
	return s.split("&").join("&amp;").split("<").join("&lt;").split(">").join("&gt;");
};
js.Boot.__trace = function(v,i) {
	var msg;
	if(i != null) msg = i.fileName + ":" + i.lineNumber + ": "; else msg = "";
	msg += js.Boot.__string_rec(v,"");
	if(i != null && i.customParams != null) {
		var _g = 0;
		var _g1 = i.customParams;
		while(_g < _g1.length) {
			var v1 = _g1[_g];
			++_g;
			msg += "," + js.Boot.__string_rec(v1,"");
		}
	}
	var d;
	if(typeof(document) != "undefined" && (d = document.getElementById("haxe:trace")) != null) d.innerHTML += js.Boot.__unhtml(msg) + "<br/>"; else if(typeof console != "undefined" && console.log != null) console.log(msg);
};
js.Boot.getClass = function(o) {
	if((o instanceof Array) && o.__enum__ == null) return Array; else return o.__class__;
};
js.Boot.__string_rec = function(o,s) {
	if(o == null) return "null";
	if(s.length >= 5) return "<...>";
	var t = typeof(o);
	if(t == "function" && (o.__name__ || o.__ename__)) t = "object";
	switch(t) {
	case "object":
		if(o instanceof Array) {
			if(o.__enum__) {
				if(o.length == 2) return o[0];
				var str = o[0] + "(";
				s += "\t";
				var _g1 = 2;
				var _g = o.length;
				while(_g1 < _g) {
					var i = _g1++;
					if(i != 2) str += "," + js.Boot.__string_rec(o[i],s); else str += js.Boot.__string_rec(o[i],s);
				}
				return str + ")";
			}
			var l = o.length;
			var i1;
			var str1 = "[";
			s += "\t";
			var _g2 = 0;
			while(_g2 < l) {
				var i2 = _g2++;
				str1 += (i2 > 0?",":"") + js.Boot.__string_rec(o[i2],s);
			}
			str1 += "]";
			return str1;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( e ) {
			return "???";
		}
		if(tostr != null && tostr != Object.toString) {
			var s2 = o.toString();
			if(s2 != "[object Object]") return s2;
		}
		var k = null;
		var str2 = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		for( var k in o ) {
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str2.length != 2) str2 += ", \n";
		str2 += s + k + " : " + js.Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str2 += "\n" + s + "}";
		return str2;
	case "function":
		return "<function>";
	case "string":
		return o;
	default:
		return String(o);
	}
};
js.Boot.__interfLoop = function(cc,cl) {
	if(cc == null) return false;
	if(cc == cl) return true;
	var intf = cc.__interfaces__;
	if(intf != null) {
		var _g1 = 0;
		var _g = intf.length;
		while(_g1 < _g) {
			var i = _g1++;
			var i1 = intf[i];
			if(i1 == cl || js.Boot.__interfLoop(i1,cl)) return true;
		}
	}
	return js.Boot.__interfLoop(cc.__super__,cl);
};
js.Boot.__instanceof = function(o,cl) {
	if(cl == null) return false;
	switch(cl) {
	case Int:
		return (o|0) === o;
	case Float:
		return typeof(o) == "number";
	case Bool:
		return typeof(o) == "boolean";
	case String:
		return typeof(o) == "string";
	case Array:
		return (o instanceof Array) && o.__enum__ == null;
	case Dynamic:
		return true;
	default:
		if(o != null) {
			if(typeof(cl) == "function") {
				if(o instanceof cl) return true;
				if(js.Boot.__interfLoop(js.Boot.getClass(o),cl)) return true;
			}
		} else return false;
		if(cl == Class && o.__name__ != null) return true;
		if(cl == Enum && o.__ename__ != null) return true;
		return o.__enum__ == cl;
	}
};
js.Boot.__cast = function(o,t) {
	if(js.Boot.__instanceof(o,t)) return o; else throw "Cannot cast " + Std.string(o) + " to " + Std.string(t);
};
openfl._Vector = {};
openfl._Vector.Vector_Impl_ = function() { };
openfl._Vector.Vector_Impl_.__name__ = true;
openfl._Vector.Vector_Impl_._new = function(length,fixed) {
	if(fixed == null) fixed = false;
	if(length == null) length = 0;
	var this1;
	this1 = new openfl.VectorData();
	var this2;
	this2 = new Array(length);
	this1.data = this2;
	this1.length = length;
	this1.fixed = fixed;
	return this1;
};
openfl._Vector.Vector_Impl_.concat = function(this1,a) {
	var vectorData = new openfl.VectorData();
	if(a != null) vectorData.length = this1.length + a.length; else vectorData.length = this1.length;
	vectorData.fixed = false;
	var this2;
	this2 = new Array(vectorData.length);
	vectorData.data = this2;
	haxe.ds._Vector.Vector_Impl_.blit(this1.data,0,vectorData.data,0,this1.length);
	if(a != null) haxe.ds._Vector.Vector_Impl_.blit(a.data,0,vectorData.data,this1.length,a.length);
	return vectorData;
};
openfl._Vector.Vector_Impl_.copy = function(this1) {
	var vectorData = new openfl.VectorData();
	vectorData.length = this1.length;
	vectorData.fixed = this1.fixed;
	var this2;
	this2 = new Array(this1.length);
	vectorData.data = this2;
	haxe.ds._Vector.Vector_Impl_.blit(this1.data,0,vectorData.data,0,this1.length);
	return vectorData;
};
openfl._Vector.Vector_Impl_.iterator = function(this1) {
	return new openfl.VectorDataIterator(this1);
};
openfl._Vector.Vector_Impl_.join = function(this1,sep) {
	var output = "";
	var _g1 = 0;
	var _g = this1.length;
	while(_g1 < _g) {
		var i = _g1++;
		if(i > 0) output += sep;
		output += Std.string(this1.data[i]);
	}
	return output;
};
openfl._Vector.Vector_Impl_.pop = function(this1) {
	var value = null;
	if(!this1.fixed) {
		if(this1.length > 0) {
			this1.length--;
			value = this1.data[this1.length];
		}
	}
	return value;
};
openfl._Vector.Vector_Impl_.push = function(this1,x) {
	if(!this1.fixed) {
		this1.length++;
		if(this1.data.length < this1.length) {
			var data;
			var this2;
			this2 = new Array(this1.data.length + 10);
			data = this2;
			haxe.ds._Vector.Vector_Impl_.blit(this1.data,0,data,0,this1.data.length);
			this1.data = data;
		}
		this1.data[this1.length - 1] = x;
	}
	return this1.length;
};
openfl._Vector.Vector_Impl_.reverse = function(this1) {
	var data;
	var this2;
	this2 = new Array(this1.length);
	data = this2;
	var _g1 = 0;
	var _g = this1.length;
	while(_g1 < _g) {
		var i = _g1++;
		data[this1.length - 1 - i] = this1.data[i];
	}
	this1.data = data;
};
openfl._Vector.Vector_Impl_.shift = function(this1) {
	if(!this1.fixed && this1.length > 0) {
		this1.length--;
		var value = this1.data[0];
		haxe.ds._Vector.Vector_Impl_.blit(this1.data,1,this1.data,0,this1.length);
		return value;
	}
	return null;
};
openfl._Vector.Vector_Impl_.unshift = function(this1,x) {
	if(!this1.fixed) {
		this1.length++;
		if(this1.data.length < this1.length) {
			var data;
			var this2;
			this2 = new Array(this1.length + 10);
			data = this2;
			haxe.ds._Vector.Vector_Impl_.blit(this1.data,0,data,1,this1.data.length);
			this1.data = data;
		} else haxe.ds._Vector.Vector_Impl_.blit(this1.data,0,this1.data,1,this1.length - 1);
		this1.data[0] = x;
	}
};
openfl._Vector.Vector_Impl_.slice = function(this1,pos,end) {
	if(end == null) end = 0;
	if(pos == null) pos = 0;
	if(pos < 0) pos += this1.length;
	if(end <= 0) end += this1.length;
	if(end > this1.length) end = this1.length;
	var length = end - pos;
	if(length <= 0 || length > this1.length) length = this1.length;
	var vectorData = new openfl.VectorData();
	vectorData.length = end - pos;
	vectorData.fixed = true;
	var this2;
	this2 = new Array(length);
	vectorData.data = this2;
	haxe.ds._Vector.Vector_Impl_.blit(this1.data,pos,vectorData.data,0,length);
	return vectorData;
};
openfl._Vector.Vector_Impl_.sort = function(this1,f) {
	var array = haxe.ds._Vector.Vector_Impl_.toArray(this1.data);
	array.sort(f);
	var vec;
	var this2;
	this2 = new Array(array.length);
	vec = this2;
	var _g1 = 0;
	var _g = array.length;
	while(_g1 < _g) {
		var i = _g1++;
		vec[i] = array[i];
	}
	this1.data = vec;
};
openfl._Vector.Vector_Impl_.splice = function(this1,pos,len) {
	if(pos < 0) pos += this1.length;
	if(pos + len > this1.length) len = this1.length - pos;
	if(len < 0) len = 0;
	var vectorData = new openfl.VectorData();
	vectorData.length = len;
	vectorData.fixed = false;
	var this2;
	this2 = new Array(len);
	vectorData.data = this2;
	haxe.ds._Vector.Vector_Impl_.blit(this1.data,pos,vectorData.data,0,len);
	if(len > 0) {
		this1.length -= len;
		haxe.ds._Vector.Vector_Impl_.blit(this1.data,pos + len,this1.data,pos,this1.length - pos);
	}
	return vectorData;
};
openfl._Vector.Vector_Impl_.toString = function(this1) {
	return haxe.ds._Vector.Vector_Impl_.toArray(this1.data).toString();
};
openfl._Vector.Vector_Impl_.indexOf = function(this1,x,from) {
	if(from == null) from = 0;
	var value = -1;
	var _g1 = from;
	var _g = this1.length;
	while(_g1 < _g) {
		var i = _g1++;
		if(this1.data[i] == x) {
			value = i;
			break;
		}
	}
	return value;
};
openfl._Vector.Vector_Impl_.lastIndexOf = function(this1,x,from) {
	if(from == null) from = 0;
	var value = -1;
	var i = this1.length - 1;
	while(i >= from) {
		if(this1.data[i] == x) {
			value = i;
			break;
		}
		i--;
	}
	return value;
};
openfl._Vector.Vector_Impl_.ofArray = function(a) {
	var vectorData = new openfl.VectorData();
	vectorData.length = a.length;
	vectorData.fixed = true;
	var vec;
	var this1;
	this1 = new Array(a.length);
	vec = this1;
	var _g1 = 0;
	var _g = a.length;
	while(_g1 < _g) {
		var i = _g1++;
		vec[i] = a[i];
	}
	vectorData.data = vec;
	return vectorData;
};
openfl._Vector.Vector_Impl_.convert = function(v) {
	return v;
};
openfl._Vector.Vector_Impl_.get = function(this1,index) {
	return this1.data[index];
};
openfl._Vector.Vector_Impl_.set = function(this1,key,value) {
	if(!this1.fixed) {
		if(key >= this1.length) this1.length = key + 1;
		if(this1.data.length < this1.length) {
			var data;
			var this2;
			this2 = new Array(this1.data.length + 10);
			data = this2;
			haxe.ds._Vector.Vector_Impl_.blit(this1.data,0,data,0,this1.data.length);
			this1.data = data;
		}
	}
	return this1.data[key] = value;
};
openfl._Vector.Vector_Impl_.fromArray = function(value) {
	var vectorData = new openfl.VectorData();
	vectorData.length = value.length;
	vectorData.fixed = true;
	var vec;
	var this1;
	this1 = new Array(value.length);
	vec = this1;
	var _g1 = 0;
	var _g = value.length;
	while(_g1 < _g) {
		var i = _g1++;
		vec[i] = value[i];
	}
	vectorData.data = vec;
	return vectorData;
};
openfl._Vector.Vector_Impl_.toArray = function(this1) {
	var value = new Array();
	var _g1 = 0;
	var _g = this1.data.length;
	while(_g1 < _g) {
		var i = _g1++;
		value.push(this1.data[i]);
	}
	return value;
};
openfl._Vector.Vector_Impl_.fromHaxeVector = function(value) {
	var vectorData = new openfl.VectorData();
	vectorData.length = value.length;
	vectorData.fixed = true;
	vectorData.data = value;
	return vectorData;
};
openfl._Vector.Vector_Impl_.toHaxeVector = function(this1) {
	return this1.data;
};
openfl._Vector.Vector_Impl_.fromVectorData = function(value) {
	return value;
};
openfl._Vector.Vector_Impl_.toVectorData = function(this1) {
	return this1;
};
openfl._Vector.Vector_Impl_.get_length = function(this1) {
	return this1.length;
};
openfl._Vector.Vector_Impl_.set_length = function(this1,value) {
	if(!this1.fixed) {
		if(value > this1.length) {
			var data;
			var this2;
			this2 = new Array(value);
			data = this2;
			haxe.ds._Vector.Vector_Impl_.blit(this1.data,0,data,0,Std["int"](Math.min(this1.data.length,value)));
			this1.data = data;
		}
		this1.length = value;
	}
	return value;
};
openfl._Vector.Vector_Impl_.get_fixed = function(this1) {
	return this1.fixed;
};
openfl._Vector.Vector_Impl_.set_fixed = function(this1,value) {
	return this1.fixed = value;
};
openfl.VectorData = function() {
	this.length = 0;
};
openfl.VectorData.__name__ = true;
openfl.VectorData.prototype = {
	__class__: openfl.VectorData
};
openfl.VectorDataIterator = function(data) {
	this.index = 0;
	this.vectorData = data;
};
openfl.VectorDataIterator.__name__ = true;
openfl.VectorDataIterator.prototype = {
	hasNext: function() {
		return this.index < this.vectorData.length;
	}
	,next: function() {
		var index = this.index++;
		return this.vectorData.data[index];
	}
	,__class__: openfl.VectorDataIterator
};
var $_, $fid = 0;
function $bind(o,m) { if( m == null ) return null; if( m.__id__ == null ) m.__id__ = $fid++; var f; if( o.hx__closures__ == null ) o.hx__closures__ = {}; else f = o.hx__closures__[m.__id__]; if( f == null ) { f = function(){ return f.method.apply(f.scope, arguments); }; f.scope = o; f.method = m; o.hx__closures__[m.__id__] = f; } return f; }
if(Array.prototype.indexOf) HxOverrides.indexOf = function(a,o,i) {
	return Array.prototype.indexOf.call(a,o,i);
};
Math.NaN = Number.NaN;
Math.NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
Math.POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
Math.isFinite = function(i) {
	return isFinite(i);
};
Math.isNaN = function(i1) {
	return isNaN(i1);
};
String.prototype.__class__ = String;
String.__name__ = true;
Array.__name__ = true;
Date.prototype.__class__ = Date;
Date.__name__ = ["Date"];
var Int = { __name__ : ["Int"]};
var Dynamic = { __name__ : ["Dynamic"]};
var Float = Number;
Float.__name__ = ["Float"];
var Bool = Boolean;
Bool.__ename__ = ["Bool"];
var Class = { __name__ : ["Class"]};
var Enum = { };
if(Array.prototype.map == null) Array.prototype.map = function(f) {
	var a = [];
	var _g1 = 0;
	var _g = this.length;
	while(_g1 < _g) {
		var i = _g1++;
		a[i] = f(this[i]);
	}
	return a;
};
var EventEmitter__0 = require("events").EventEmitter;
var Crypto__7 = require("crypto");
var Http__5 = require("http");
var Https__1 = require("https");
var Net__10 = require("net");
var Url__8 = require("url");
var Agent__6 = require("http").Agent;
var ClientRequest__12 = require("http").ClientRequest;
var Server__4 = require("http").Server;
var Writable__2 = require("stream").Writable;
var ServerResponse__3 = require("http").ServerResponse;
var Server__11 = require("net").Server;
var Socket__9 = require("net").Socket;
fovea.async.Deferred.PENDING = 0;
fovea.async.Deferred.RESOLVED = 1;
fovea.async.Deferred.REJECTED = 2;
fovea.async.Deferred.ABORTED = 3;
fovea.events.Event.ACTIVATE = "activate";
fovea.events.Event.ADDED = "added";
fovea.events.Event.ADDED_TO_STAGE = "addedToStage";
fovea.events.Event.CANCEL = "cancel";
fovea.events.Event.CHANGE = "change";
fovea.events.Event.CLOSE = "close";
fovea.events.Event.COMPLETE = "complete";
fovea.events.Event.CONNECT = "connect";
fovea.events.Event.CONTEXT3D_CREATE = "context3DCreate";
fovea.events.Event.DEACTIVATE = "deactivate";
fovea.events.Event.ENTER_FRAME = "enterFrame";
fovea.events.Event.ID3 = "id3";
fovea.events.Event.INIT = "init";
fovea.events.Event.MOUSE_LEAVE = "mouseLeave";
fovea.events.Event.OPEN = "open";
fovea.events.Event.REMOVED = "removed";
fovea.events.Event.REMOVED_FROM_STAGE = "removedFromStage";
fovea.events.Event.RENDER = "render";
fovea.events.Event.RESIZE = "resize";
fovea.events.Event.SCROLL = "scroll";
fovea.events.Event.SELECT = "select";
fovea.events.Event.SOUND_COMPLETE = "soundComplete";
fovea.events.Event.TAB_CHILDREN_CHANGE = "tabChildrenChange";
fovea.events.Event.TAB_ENABLED_CHANGE = "tabEnabledChange";
fovea.events.Event.TAB_INDEX_CHANGE = "tabIndexChange";
fovea.events.Event.UNLOAD = "unload";
fovea.events.Events.CHANGE = "change";
fovea.net.Ajax.verbose = false;
openfl.errors.Error.DEFAULT_TO_STRING = "Error";
fovea.net.AjaxError.HTTP_ERROR = "HTTP";
fovea.net.AjaxError.IO_ERROR = "IO";
fovea.net.AjaxError.SECURITY_ERROR = "SECURITY";
fovea.net.AjaxError.CLIENT_ERROR = "CLIENT";
fovea.net.AjaxError.IO_ERROR_JSON = 1;
fovea.ganomede.ApiError.INVALID = "StormpathResourceError400";
fovea.ganomede.ApiError.ALREADY_EXISTS = "StormpathResourceError2001";
fovea.ganomede.GanomedeAvatars.TYPE = "avatars/v1";
fovea.ganomede.GanomedeChallengesClient.TYPE = "challenges/v1";
fovea.ganomede.GanomedeChatClient.TYPE = "chat/v1";
fovea.ganomede.GanomedeCoordinatorClient.TYPE = "coordinator/v1";
fovea.ganomede.GanomedeData.TYPE = "data/v1";
fovea.ganomede.GanomedeEvents.AUTH = "ganomede.auth";
fovea.ganomede.GanomedeEvents.LOGIN = "ganomede.login";
fovea.ganomede.GanomedeEvents.LOGOUT = "ganomede.logout";
fovea.ganomede.GanomedeEvents.CHANGE = "ganomede.change";
fovea.ganomede.GanomedeInvitationsClient.TYPE = "invitations/v1";
fovea.ganomede.GanomedeNotificationsClient.TYPE = "notifications/v1";
fovea.ganomede.GanomedeStatistics.TYPE = "statistics/v1";
fovea.ganomede.GanomedeTurnGameClient.TYPE = "turngame/v1";
fovea.ganomede.GanomedeUsers.TYPE = "users/v1";
fovea.ganomede.GanomedeVirtualCurrencyClient.TYPE = "virtualcurrency/v1";
fovea.ganomede.models.GanomedePackPurchase.TYPE_IOS_APPSTORE = "ios-appstore";
fovea.ganomede.models.GanomedePackPurchase.TYPE_ANDROID_PLAYSTORE = "android-playstore";
fovea.ganomede.models.GanomedePackPurchase.TYPE_CLAIM = "claim";
fovea.ganomede.models.GanomedePushToken.TYPE_APN = "apn";
fovea.ganomede.models.GanomedePushToken.TYPE_GCM = "gcm";
})(typeof window != "undefined" ? window : exports);
