package fovea.async {
	import fovea.async.Deferred;
	import fovea.async.Promise;
	import haxe.Timer;
	public class Waterfall {
		static public function run(fn : Array) : fovea.async.Promise {
			var deferred : fovea.async.Deferred = new fovea.async.Deferred();
			if(fn.length == 0) {
				deferred.resolve();
				return deferred;
			};
			haxe.Timer.delay(function() : Function {
				var $r : Function;
				var onTick : Function = function() : void {
					var f : Function = fn.shift();
					f().then(function() : Function {
						var $r2 : Function;
						var onResolve : Function = function(outcome : *) : void {
							fovea.async.Waterfall.run(fn).then(deferred.resolve).error(deferred.reject);
						}
						$r2 = onResolve;
						return $r2;
					}()).error(deferred.reject);
				}
				$r = onTick;
				return $r;
			}(),0);
			return deferred;
		}
		
	}
}
