package fovea.ganomede {
	import fovea.ganomede.AuthenticatedClient;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeChatMessage;
	import fovea.ganomede.GanomedeChatRoom;
	import flash.Boot;
	public class GanomedeChatClient extends fovea.ganomede.AuthenticatedClient {
		public function GanomedeChatClient(baseUrl : String = null,token : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super(baseUrl,"chat/v1",token);
		}}
		
		public function joinRoom(room : fovea.ganomede.GanomedeChatRoom) : fovea.async.Promise {
			return this.ajax("POST","/rooms",{ data : { type : room.type, users : room.users}}).then(function(result : *) : void {
				if(result.data.id) room.fromJSON(result.data);
			});
		}
		
		public function encodeURIComponent(s : String) : String {
			return StringTools.replace(s,"/","%2F");
		}
		
		public function loadRoom(room : fovea.ganomede.GanomedeChatRoom) : fovea.async.Promise {
			return this.ajax("GET","/rooms/" + this.encodeURIComponent(room.id)).then(function(result : *) : void {
				if(result.data.id) room.fromJSON(result.data);
			});
		}
		
		public function postMessage(room : fovea.ganomede.GanomedeChatRoom,message : fovea.ganomede.GanomedeChatMessage) : fovea.async.Promise {
			return this.ajax("POST","/rooms/" + this.encodeURIComponent(room.id) + "/messages",{ data : message.toJSON()});
		}
		
		static public var TYPE : String = "chat/v1";
	}
}
