package fovea.ganomede {
	import fovea.ganomede.GanomedeAvatars;
	import fovea.ganomede.GanomedeGames;
	import fovea.ganomede.GanomedeStatistics;
	import fovea.ganomede.GanomedeChats;
	import fovea.ganomede.GanomedeNotifications;
	import fovea.ganomede.GanomedeRegistry;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeUsers;
	import fovea.ganomede.GanomedeTurnGames;
	import fovea.async.Parallel;
	import fovea.ganomede.GanomedeInvitations;
	import fovea.ganomede.ApiClient;
	import flash.Boot;
	public class GanomedeClient extends fovea.ganomede.ApiClient {
		public function GanomedeClient(url : String = null,options : * = null) : void { if( !flash.Boot.skip_constructor ) {
			super(url);
			this.options = options;
			if(!options) this.options = options = { };
			if(!options.registry) options.registry = { };
			if(!options.games) options.games = { };
			if(!options.notifications) options.notifications = { };
			if(!options.invitations) options.invitations = { };
			if(!options.users) options.users = { };
			if(!options.turngames) options.turngames = { };
			if(!options.avatars) options.avatars = { };
			if(!options.chats) options.chats = { };
			if(!options.statistics) options.statistics = { };
			if(options.registry.enabled) this.registry = new fovea.ganomede.GanomedeRegistry(this,url + "/registry/v1");
			if(options.users.enabled) this.users = new fovea.ganomede.GanomedeUsers(this);
			if(options.notifications.enabled) this.notifications = new fovea.ganomede.GanomedeNotifications(this);
			if(options.invitations.enabled) this.invitations = new fovea.ganomede.GanomedeInvitations(this);
			if(options.games.enabled) this.games = new fovea.ganomede.GanomedeGames(this,options.games.type);
			if(options.turngames.enabled) this.turngames = new fovea.ganomede.GanomedeTurnGames(this);
			if(options.avatars.enabled) this.avatars = new fovea.ganomede.GanomedeAvatars(this);
			if(options.chats.enabled) this.chats = new fovea.ganomede.GanomedeChats(this);
			if(options.statistics.enabled) this.statistics = new fovea.ganomede.GanomedeStatistics(this,options.games.type);
		}}
		
		public var initialized : Boolean = false;
		public var registry : fovea.ganomede.GanomedeRegistry;
		public var users : fovea.ganomede.GanomedeUsers;
		public var invitations : fovea.ganomede.GanomedeInvitations;
		public var notifications : fovea.ganomede.GanomedeNotifications;
		public var games : fovea.ganomede.GanomedeGames;
		public var turngames : fovea.ganomede.GanomedeTurnGames;
		public var avatars : fovea.ganomede.GanomedeAvatars;
		public var chats : fovea.ganomede.GanomedeChats;
		public var statistics : fovea.ganomede.GanomedeStatistics;
		public var options : * = { }
		public function initialize() : fovea.async.Promise {
			var _g : fovea.ganomede.GanomedeClient = this;
			var a : Array = [];
			if(this.registry != null) a.push(this.registry.initialize);
			if(this.users != null) a.push(this.users.initialize);
			if(this.invitations != null) a.push(this.invitations.initialize);
			if(this.notifications != null) a.push(this.notifications.initialize);
			if(this.games != null) a.push(this.games.initialize);
			if(this.turngames != null) a.push(this.turngames.initialize);
			if(this.avatars != null) a.push(this.avatars.initialize);
			if(this.chats != null) a.push(this.chats.initialize);
			if(this.statistics != null) a.push(this.statistics.initialize);
			return fovea.async.Parallel.run(a).then(function(outcome : *) : void {
				_g.initialized = true;
			});
		}
		
	}
}
