package fovea.ganomede {
	import fovea.ganomede.GanomedeNotification;
	import fovea.ganomede.AuthenticatedClient;
	import fovea.net.UrlFormatter;
	import fovea.async.Deferred;
	import fovea.async.Promise;
	import flash.Boot;
	public class GanomedeNotificationsClient extends fovea.ganomede.AuthenticatedClient {
		public function GanomedeNotificationsClient(baseUrl : String = null,token : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super(baseUrl,"notifications/v1",token);
		}}
		
		public var polling : Boolean = false;
		public function poll(after : int) : fovea.async.Promise {
			if(this.polling) {
				var deferred : fovea.async.Deferred = new fovea.async.Deferred();
				return deferred;
			};
			this.polling = true;
			var uri : String = fovea.net.UrlFormatter.format("/messages",{ after : after});
			return this.ajax("GET",uri,{ parse : this.parseArray, silentIOError : true}).then(this.pollSuccess).error(this.pollError);
		}
		
		public function online() : fovea.async.Promise {
			return this.ajax("GET","/online");
		}
		
		public function pollSuccess(outcome : *) : void {
			outcome.token = this.token;
			outcome.clientId = this.clientId;
			this.polling = false;
		}
		
		public function pollError(error : Error) : void {
			this.polling = false;
		}
		
		public function parseArray(obj : *) : * {
			var array : Array;
			array = (function($this:GanomedeNotificationsClient) : Array {
				var $r : Array;
				var $t : * = obj;
				if(Std._is($t,Array)) (($t) as Array);
				else throw "Class cast error";
				$r = $t;
				return $r;
			}(this));
			if(array == null) return obj;
			var i : int;
			{
				var _g1 : int = 0;
				var _g : int = array.length;
				while(_g1 < _g) {
					var i1 : int = _g1++;
					array[i1] = new fovea.ganomede.GanomedeNotification(array[i1]);
				}
			};
			return array;
		}
		
		static public var TYPE : String = "notifications/v1";
	}
}
