package fovea.ganomede {
	import flash.Boot;
	public class GanomedeService {
		public function GanomedeService(obj : * = null) : void { if( !flash.Boot.skip_constructor ) {
			if(obj == null) return;
			this.type = obj.type;
			this.version = obj.version;
			this.description = obj.description;
			this.host = obj.host;
			this.port = obj.port;
			this.pingMs = obj.pingMs;
		}}
		
		public var type : String;
		public var version : String;
		public var description : String;
		public var host : String;
		public var port : int;
		public var pingMs : int;
		public function splitVersion() : Array {
			var sret : Array;
			var ret : Array = new Array();
			if(this.version != null) {
				sret = this.version.split(".");
				{
					var _g1 : int = 0;
					var _g : int = sret.length;
					while(_g1 < _g) {
						var i : int = _g1++;
						ret.push(Std._parseInt(sret[i]));
					}
				}
			};
			while(ret.length < 3) ret.push(0);
			return ret;
		}
		
		public function versionMajor() : int {
			return this.splitVersion()[0];
		}
		
		public function versionMinor() : int {
			return this.splitVersion()[1];
		}
		
		public function versionPatch() : int {
			return this.splitVersion()[2];
		}
		
		public function versionGE(major : int,minor : int = 0,patch : int = 0) : Boolean {
			var v : Array = this.splitVersion();
			if(v[0] > major) return true;
			if(v[0] < major) return false;
			if(v[1] > minor) return true;
			if(v[1] < minor) return false;
			if(v[2] >= patch) return true;
			return false;
		}
		
	}
}
