package fovea.ganomede {
	import fovea.async.Deferred;
	import fovea.async.Promise;
	import fovea.ganomede.GanomedeClient;
	import fovea.ganomede.ApiClient;
	import flash.Boot;
	public class GanomedeStatistics extends fovea.ganomede.ApiClient {
		public function GanomedeStatistics(client : fovea.ganomede.GanomedeClient = null,gameType : String = null) : void { if( !flash.Boot.skip_constructor ) {
			super(client.url + "/" + "statistics/v1" + "/" + gameType);
		}}
		
		public function initialize() : fovea.async.Promise {
			return new fovea.async.Deferred().resolve(null);
		}
		
		public function getRank(username : String) : fovea.async.Promise {
			return this.ajaxGetData(fovea.ganomede.GanomedeStatistics.makePath(username,"rank"));
		}
		
		public function getLevel(username : String) : fovea.async.Promise {
			return this.ajaxGetData(fovea.ganomede.GanomedeStatistics.makePath(username,"level"));
		}
		
		public function getArchive(username : String) : fovea.async.Promise {
			return this.ajaxGetData(fovea.ganomede.GanomedeStatistics.makePath(username,"archive"));
		}
		
		static public var TYPE : String = "statistics/v1";
		static public function makePath(username : String,endpoint : String) : String {
			return "/" + username + "/" + endpoint;
		}
		
	}
}
