package fovea.ganomede {
	import fovea.utils.Model;
	import fovea.ganomede.GanomedeGame;
	import flash.Boot;
	public class GanomedeTurnGame extends fovea.utils.Model {
		public function GanomedeTurnGame(obj : * = null) : void { if( !flash.Boot.skip_constructor ) {
			super(obj);
		}}
		
		public var type : String;
		public var players : Array;
		public var turn : String;
		public var status : String;
		public var gameData : *;
		public var gameConfig : *;
		public var url : String;
		public function fromGame(game : fovea.ganomede.GanomedeGame) : fovea.ganomede.GanomedeTurnGame {
			this.fromJSON(game.toJSON());
			return this;
		}
		
		public override function fromJSON(obj : *) : void {
			if(obj == null) return;
			if(obj.id && this.id != obj.id) {
				this.id = obj.id;
				this.dispatchUpdate();
			};
			if(obj.type && this.type != obj.type) {
				this.type = obj.type;
				this.dispatchUpdate();
			};
			if(obj.players && this.players != obj.players) {
				this.players = obj.players;
				this.dispatchUpdate();
			};
			if(obj.turn && this.turn != obj.turn) {
				this.turn = obj.turn;
				this.dispatchUpdate();
			};
			if(obj.status && this.status != obj.status) {
				this.status = obj.status;
				this.dispatchUpdate();
			};
			if(obj.gameData && this.gameData != obj.gameData) {
				this.gameData = obj.gameData;
				this.dispatchUpdate();
			};
			if(obj.gameConfig && this.gameConfig != obj.gameConfig) {
				this.gameConfig = obj.gameConfig;
				this.dispatchUpdate();
			};
			if(obj.url && this.url != obj.url) {
				this.url = obj.url;
				this.dispatchUpdate();
			}
		}
		
		protected var listeners : Array = new Array();
		public function addListener(fn : Function) : void {
			this.listeners.push(fn);
		}
		
		public function removeListener(fn : Function) : void {
			this.listeners.remove(fn);
		}
		
		protected function dispatchUpdate() : void {
			var _g1 : int = 0;
			var _g : int = this.listeners.length;
			while(_g1 < _g) {
				var i : int = _g1++;
				this.listeners[i]();
			}
		}
		
		public override function toJSON() : * {
			return { id : this.id, type : this.type, players : this.players, turn : this.turn, status : this.status, gameData : this.gameData, gameConfig : this.gameConfig, url : this.url}
		}
		
	}
}
